/*
 * cpudefs.h
 *
 * CPU inclusion control.
 */

/* $Id: cpudefs.h,v 1.4 1999/01/03 00:19:32 nyef Exp $ */

#ifndef __CPUDEFS_H__
#define __CPUDEFS_H__

/*
 * choose which CPU cores to use.
 * this should probably be shifted out to a separate config program.
 */

#define CPU_MARAT6502
#define CPU_EMU6502
#define CPU_EMU6502A
#define CPU_EMU65C02
#define CPU_EMU6280
#define CPU_MARATZ80
#define CPU_EMUZ80

/*
 * handle CPU dependancies.
 */

#ifdef CPU_EMU6502A
#  ifndef CPU_EMU6502
#    warning The emu6502a CPU core requires the emu6502 core. (not configured)
#    define CPUDEP_ERROR
#  endif
#endif

#ifdef CPU_EMU65C02
#  ifndef CPU_EMU6502
#    warning The emu65c02 CPU core requires the emu6502 core. (not configured)
#    define CPUDEP_ERROR
#  endif
#endif

#ifdef CPU_EMU6280
#  ifndef CPU_EMU65C02
#    warning The emu6280 CPU core requires the emu65c02 core. (not configured)
#    define CPUDEP_ERROR
#  endif
#  ifndef CPU_EMU6502
#    warning The emu6280 CPU core requires the emu6502 core. (not configured)
#    define CPUDEP_ERROR
#  endif
#endif

#ifdef CPUDEP_ERROR
#  error CPU core dependancy problem. (Your fault: core dumped)
#endif

#endif /* __CPUDEFS_H__ */

/*
 * $Log: cpudefs.h,v $
 * Revision 1.4  1999/01/03 00:19:32  nyef
 * added maratz80 cupport.
 *
 * Revision 1.3  1999/01/01 07:00:25  nyef
 * added emuz80 support
 *
 * Revision 1.2  1998/12/12 20:35:41  nyef
 * enabled marat6502 support
 *
 * Revision 1.1  1998/11/29 18:29:03  nyef
 * Initial revision
 *
 */
