/*
 * deb_tabs.c
 *
 * debug tables for tool.c
 */

/* $Id: dt6280.c,v 1.7 1999/05/30 05:12:56 nyef Exp $ */

#include <stdio.h>
#include "debug.h"
#include "dt6280.h"

static char instrs[256][5] = {
    "BRK", "ORA", "SXY", "ST0",   "TSB", "ORA", "ASL", "RMB0",  /* 00-07 */
    "PHP", "ORA", "ASL", "???",   "TSB", "ORA", "ASL", "BBR0",  /* 08-0F */
    "BPL", "ORA", "ORA", "ST1",   "TRB", "ORA", "ASL", "RMB1",  /* 10-17 */
    "CLC", "ORA", "INC", "???",   "TRB", "ORA", "ASL", "BBR1",  /* 18-1F */
    "JSR", "AND", "SAX", "ST2",   "BIT", "AND", "ROL", "RMB2",  /* 20-27 */
    "PLP", "AND", "ROL", "???",   "BIT", "AND", "ROL", "BBR2",  /* 28-2F */
    "BMI", "AND", "AND", "???",   "BIT", "AND", "ROL", "RMB3",  /* 30-37 */
    "SEC", "AND", "DEC", "???",   "BIT", "AND", "ROL", "BBR3",  /* 38-3F */
    "RTI", "EOR", "SAY", "TMA",   "BSR", "EOR", "LSR", "RMB4",  /* 40-47 */
    "PHA", "EOR", "LSR", "???",   "JMP", "EOR", "LSR", "BBR4",  /* 48-4F */
    "BVC", "EOR", "EOR", "TAM",   "CSL", "EOR", "LSR", "RMB5",  /* 50-57 */
    "CLI", "EOR", "PHY", "???",   "???", "EOR", "LSR", "BBR5",  /* 58-5F */
    "RTS", "ADC", "CLA", "???",   "STZ", "ADC", "ROR", "RMB6",  /* 60-67 */
    "PLA", "ADC", "ROR", "???",   "JMP", "ADC", "ROR", "BBR6",  /* 68-6F */
    "BVS", "ADC", "ADC", "TII",   "STZ", "ADC", "ROR", "RMB7",  /* 70-77 */
    "SEI", "ADC", "PLY", "???",   "JMP", "ADC", "ROR", "BBR7",  /* 78-7F */
    "BRA", "STA", "CLX", "TST",   "STY", "STA", "STX", "SMB0",  /* 80-87 */
    "DEY", "BIT", "TXA", "???",   "STY", "STA", "STX", "BBS0",  /* 88-8F */
    "BCC", "STA", "STA", "TST",   "STY", "STA", "STX", "SMB1",  /* 90-97 */
    "TYA", "STA", "TXS", "???",   "STZ", "STA", "STZ", "BBS1",  /* 98-9F */
    "LDY", "LDA", "LDX", "TST",   "LDY", "LDA", "LDX", "SMB2",  /* A0-A7 */
    "TAY", "LDA", "TAX", "???",   "LDY", "LDA", "LDX", "BBS2",  /* A8-AF */
    "BCS", "LDA", "LDA", "TST",   "LDY", "LDA", "LDX", "SMB3",  /* B0-B7 */
    "CLV", "LDA", "TSX", "???",   "LDY", "LDA", "LDX", "BBS3",  /* B8-BF */
    "CPY", "CMP", "CLY", "TDD",   "CPY", "CMP", "DEC", "SMB4",  /* C0-C7 */
    "INY", "CMP", "DEX", "???",   "CPY", "CMP", "DEC", "BBS4",  /* C8-CF */
    "BNE", "CMP", "CMP", "TIN",   "CSH", "CMP", "DEC", "SMB5",  /* D0-D7 */
    "CLD", "CMP", "PHX", "???",   "???", "CMP", "DEC", "BBS5",  /* D8-DF */
    "CPX", "SBC", "???", "TIA",   "CPX", "SBC", "INC", "SMB6",  /* E0-E7 */
    "INX", "SBC", "NOP", "???",   "CPX", "SBC", "INC", "BBS6",  /* E8-EF */
    "BEQ", "SBC", "SBC", "TAI",   "SET", "SBC", "INC", "SMB7",  /* F0-F7 */
    "SED", "SBC", "PLX", "???",   "???", "SBC", "INC", "BBS7",  /* F8-FF */
};

static int addmodes[256] = {
     0,  7, 10,  0,  1,  1,  1,  1,   /* 00-07 */
    10,  0,  2, 13,  4,  4,  4, 15,   /* 08-0F */
    11,  8, 14,  0,  1,  3,  3,  1,   /* 10-17 */
    10,  6,  2, 13,  4,  5,  5, 15,   /* 18-1F */
     4,  7, 10,  0,  1,  1,  1,  1,   /* 20-27 */
    10,  0,  2, 13,  4,  4,  4, 15,   /* 28-2F */
    11,  8, 14, 13,  3,  3,  3,  1,   /* 30-37 */
    10,  6,  2, 13,  5,  5,  5, 15,   /* 38-3F */
    10,  7, 10,  0, 11,  1,  1,  1,   /* 40-47 */
    10,  0,  2, 13,  4,  4,  4, 15,   /* 48-4F */
    11,  8, 14,  0, 10,  3,  3,  1,   /* 50-57 */
    10,  6, 10, 13, 13,  5,  5, 15,   /* 58-5F */
    10,  7, 10, 13,  1,  1,  1,  1,   /* 60-67 */
    10,  0,  2, 13,  9,  4,  4, 15,   /* 68-6F */
    11,  8, 14, 16,  3,  3,  3,  1,   /* 70-77 */
    10,  6, 10, 13,  7,  5,  5, 15,   /* 78-7F */
    11,  7, 10, 17,  1,  1,  1,  1,   /* 80-87 */
    10,  0, 10, 13,  4,  4,  4, 15,   /* 88-8F */
    11,  8, 14, 19,  3,  3, 12,  1,   /* 90-97 */
    10,  6, 10, 13,  4,  5,  5, 15,   /* 98-9F */
     0,  7,  0, 18,  1,  1,  1,  1,   /* A0-A7 */
    10,  0, 10, 13,  4,  4,  4, 15,   /* A8-AF */
    11,  8, 14, 20,  3,  3, 12,  1,   /* B0-B7 */
    10,  6, 10, 13,  5,  5,  6, 15,   /* B8-BF */
     0,  7, 10, 16,  1,  1,  1,  1,   /* C0-C7 */
    10,  0, 10, 13,  4,  4,  4, 15,   /* C8-CF */
    11,  8, 14, 16, 10,  3,  3,  1,   /* D0-D7 */
    10,  6, 10, 13, 13,  5,  5, 15,   /* D8-DF */
     0,  7, 13, 16,  1,  1,  1,  1,   /* E0-E7 */
    10,  0, 10, 13,  4,  4,  4, 15,   /* E8-EF */
    11,  8, 14, 16, 10,  3,  3,  1,   /* F0-F7 */
    10,  6, 10, 13, 13,  5,  5, 15,   /* F8-FF */
};

static char *addmodestrs[21] = {
    "%s #$%02x",          /* 0: Immediate */
    "%s $%02x",           /* 1: Zero Page */
    "%s a",               /* 2: Accumulator */
    "%s $%02x, X",        /* 3: Zero page, X */
    "%s $%04x",           /* 4: Absolute */
    "%s $%04x, X",        /* 5: Absolute, X */
    "%s $%04x, Y",        /* 6: Absolute, Y */
    "%s ($%02x, X)",      /* 7: (Indirect, X) */
    "%s ($%02x), Y",      /* 8: (Indirect), Y */
    "%s ($%04x)",         /* 9: Indirect */
    "%s",                 /* 10: Implied */
    "%s $%04x",           /* 11: Relative */
    "%s $%02x, Y",        /* 12: Zero Page, Y */
    "%s",                 /* 13: Invalid */
    "%s ($%02x)",         /* 14: (Indirect) */
    "%s $%02x, $%04x",    /* 15: ZPage Relative */
    "%s $%04x, $%04x, $%04x", /* 16: Repeat transfers */
    "%s #$%02x, $%02x",   /* 17: Immediate ZPage */
    "%s #$%02x, $%02x, X",/* 18: Immediate ZPageX */
    "%s #$%02x, $%04x",   /* 19: Immediate Absolute */
    "%s #$%02x, $%04x, X",/* 20: Immediate AbsoluteX */
};

static int instr_lengths[21] = {2, 2, 1, 2, 3, 3, 3, 2, 2, 3, 1, 2, 2, 1, 2, 3, 7, 3, 3, 4, 4};

static int disassemble_instr(char *buf, int address, UCHAR d1, UCHAR d2, UCHAR d3,
		      UCHAR d4, UCHAR d5, UCHAR d6, UCHAR d7)
{
    switch(addmodes[d1]) {
    case 2: case 10: case 13:
        sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1]);
        break;

    case 0: case 1: case 3: case 7: case 8: case 12: case 14:
        sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], d2);
        break;

    case 17: case 18:
        sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], d2, d3);
        break;

    case 4: case 5: case 6: case 9:
        sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], ((d3<<8)+d2));
        break;

    case 16:
	sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], ((d3<<8)+d2), ((d5<<8)+d4), ((d7<<8)+d6));
        break;

    case 11:
        sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], (address+2+((signed char)d2)) & 0xffff);
        break;

    case 15:
        sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], d2, (address+3+((signed char)d3)) & 0xffff);
        break;
	
    case 19: case 20:
	sprintf(buf, addmodestrs[addmodes[d1]], instrs[d1], d2, ((d4<<8)+d3) & 0xffff);
	break;
	
    default:
        sprintf(buf, "<program error>");
        printf("tool: fault in disassemble_instr()\n");
    }
    return (instr_lengths[addmodes[d1]]);
}

int dt6280_disassemble(int start_addr, int end_addr) {
    int cur_addr;
    int count;
    int len;
    unsigned char d1, d2, d3, d4, d5, d6, d7;
    char buf[128];

    cur_addr = start_addr;
    count = 0;

    while (cur_addr <= end_addr) {
        d1 = mem_read_byte(cur_addr);
        d2 = mem_read_byte(cur_addr+1);
        d3 = mem_read_byte(cur_addr+2);
        d4 = mem_read_byte(cur_addr+3);
        d5 = mem_read_byte(cur_addr+4);
        d6 = mem_read_byte(cur_addr+5);
        d7 = mem_read_byte(cur_addr+6);

        len = disassemble_instr(buf, cur_addr, d1, d2, d3, d4, d5, d6, d7);
        if (len == 1) {
            printf("%04hx: %02x          %s\n", cur_addr, d1, buf);
        } else if (len == 2) {
            printf("%04hx: %02x %02x       %s\n", cur_addr, d1, d2, buf);
        } else if (len == 3) {
            printf("%04hx: %02x %02x %02x    %s\n", cur_addr, d1, d2, d3, buf);
        } else if (len == 4) {
            printf("%04hx: %02x %02x %02x %02x %s\n", cur_addr, d1, d2, d3, d4, buf);
        } else if (len == 7) {
            printf("%04hx: %02x %02x %02x %02x %02x %02x %02x    %s\n", cur_addr, d1, d2, d3, d4, d5, d6, d7, buf);
        } else {
            printf("tool: fault in disassemble()\n");
        }
        cur_addr += len;
        count += len;
    }

    return count;
}

/*
 * $Log: dt6280.c,v $
 * Revision 1.7  1999/05/30 05:12:56  nyef
 * fixed addressing mode on 0xc9 (CMP) to be immediate
 *
 * Revision 1.6  1999/05/13 01:48:51  nyef
 * fixed minor issue with 4-byte instruction display
 *
 * Revision 1.5  1999/05/12 01:54:40  nyef
 * fixed problems with ZPage relative, Immediate Absolute, and Immediate
 * Absolute X addressing modes
 *
 * Revision 1.4  1999/05/10 01:25:09  nyef
 * fixed problems with TST addressing modes
 *
 * Revision 1.3  1999/03/03 02:45:34  nyef
 * added the BSR instruction
 *
 * Revision 1.2  1998/07/14 01:54:05  nyef
 * changed all data to static
 * changed disassemble_instr() to static
 * added dt6280_disassemble() based on the code from dt6502.c
 *
 * Revision 1.1  1998/07/11 22:16:26  nyef
 * Initial revision
 *
 */
