/*
 * emu6280.h
 *
 * 6280 emulation defines
 */

/* $Id: emu6280.h,v 1.6 1999/04/17 20:06:45 nyef Exp $ */

#ifndef __EMU6280_H__
#define __EMU6280_H__

#ifndef __EMU65C02_H__
#include "emu65c02.h"
#endif

/* registers */

/* reserved memory spaces are for future expansion (e.g. 65816 emulation) */
struct emu6280_context {
    BYTE reg_A;
    BYTE reserved1;
    BYTE reg_Y;
    BYTE reserved2;
    BYTE reg_X;
    BYTE reserved3;
    BYTE reg_P;
    BYTE reg_S;
    BYTE reserved4;
    WORD reserved5;
    WORD reg_PC;
    memread8_t *readtable;
    memwrite8_t *writetable;
    void **decodetable;
    void *dispatch;
    long cycles_left;
    void *page_0; /* this should be followed contiguously by page 1 */
    long mmu_shift;
    long mmu_mask;
    void *user;
    BYTE mpr[8]; /* Memory maPping Registers */
} PACKED;


/* functions */

void emu6280_step(struct emu6280_context *context);
void emu6280_run(struct emu6280_context *context);

void emu6280_reset(struct emu6280_context *context);
void emu6280_NMI(struct emu6280_context *context);
void emu6280_TIMER(struct emu6280_context *context);
void emu6280_IRQ(struct emu6280_context *context);

void emu6280_init(struct emu6280_context *context);

#endif /* __EMU6280_H__ */

/*
 * $Log: emu6280.h,v $
 * Revision 1.6  1999/04/17 20:06:45  nyef
 * fixed for new version of the CAL.
 *
 * Revision 1.5  1999/02/15 03:24:31  nyef
 * added patch from Michael Vance to squash warnings
 *
 * Revision 1.4  1999/01/13 03:53:20  nyef
 * updated to comply with the new memory access spec.
 *
 * Revision 1.3  1998/07/14 10:35:19  nyef
 * added decodetable and dispatch to emu6280_context
 *
 * Revision 1.2  1998/07/12 21:53:21  nyef
 * changed emu6280_irq to emu6280_irq1
 * added emu6280_timer, emu6280_irq2
 *
 * Revision 1.1  1998/07/11 22:17:03  nyef
 * Initial revision
 *
 */
