/*
 * emu68k.c
 *
 * emulation of the 68000
 */

/* $Id: emu68k.c,v 1.2 1999/06/19 18:44:27 nyef Exp $ */

#include <stdlib.h>
#include "cal.h"
#include "ui.h"
#include "emu68k.h"
#include "tool.h"

typedef void (*m68k_instr_handler)(struct emu68k_context *, unsigned short);

extern struct m68k_instr m68k_grp_0[]; extern struct m68k_instr m68k_grp_1[];
extern struct m68k_instr m68k_grp_2[]; extern struct m68k_instr m68k_grp_3[];
extern struct m68k_instr m68k_grp_4[]; extern struct m68k_instr m68k_grp_5[];
extern struct m68k_instr m68k_grp_6[]; extern struct m68k_instr m68k_grp_7[];
extern struct m68k_instr m68k_grp_8[]; extern struct m68k_instr m68k_grp_9[];
extern struct m68k_instr m68k_grp_a[]; extern struct m68k_instr m68k_grp_b[];
extern struct m68k_instr m68k_grp_c[]; extern struct m68k_instr m68k_grp_d[];
extern struct m68k_instr m68k_grp_e[]; extern struct m68k_instr m68k_grp_f[];

void m68k_do_ANDI_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ANDI_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ANDI_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ORI_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ORI_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ORI_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_CMPI_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_CMPI_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_CMPI_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_CMP_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_CMP_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_CMP_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEA_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEA_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEQ(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEM_RM_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEM_RM_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEM_MR_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVEM_MR_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_CLR_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_CLR_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_CLR_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_TST_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_TST_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_TST_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_TAS(struct emu68k_context *context, unsigned short opword);
void m68k_do_BRA(struct emu68k_context *context, unsigned short opword);
void m68k_do_BSR(struct emu68k_context *context, unsigned short opword);
void m68k_do_BCC(struct emu68k_context *context, unsigned short opword);
void m68k_do_BCS(struct emu68k_context *context, unsigned short opword);
void m68k_do_BNE(struct emu68k_context *context, unsigned short opword);
void m68k_do_BEQ(struct emu68k_context *context, unsigned short opword);
void m68k_do_LEA(struct emu68k_context *context, unsigned short opword);
void m68k_do_DBF(struct emu68k_context *context, unsigned short opword);
void m68k_do_SF(struct emu68k_context *context, unsigned short opword);
void m68k_do_BTST_dyn(struct emu68k_context *context, unsigned short opword);
void m68k_do_BTST_stat(struct emu68k_context *context, unsigned short opword);
void m68k_do_SUBA_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_SUBA_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_SUBQ_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_SUBQ_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_SUBQ_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADD_d_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADD_d_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADD_d_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADD_e_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADD_e_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADD_e_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADDQ_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADDQ_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ADDQ_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_to_CCR(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_to_SR(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_from_SR(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_to_USP(struct emu68k_context *context, unsigned short opword);
void m68k_do_MOVE_from_USP(struct emu68k_context *context, unsigned short opword);
void m68k_do_RTS(struct emu68k_context *context, unsigned short opword);
void m68k_do_NOP(struct emu68k_context *context, unsigned short opword);
void m68k_do_JMP(struct emu68k_context *context, unsigned short opword);
void m68k_do_JSR(struct emu68k_context *context, unsigned short opword);
void m68k_do_LINK(struct emu68k_context *context, unsigned short opword);
void m68k_do_UNLK(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSR_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSR_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSR_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSR_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_ASR_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ASR_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ASR_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ASR_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSL_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSL_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSL_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_LSL_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROL_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROL_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROL_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROL_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROR_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROR_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROR_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROR_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXL_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXL_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXL_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXL_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXR_r_byte(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXR_r_word(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXR_r_long(struct emu68k_context *context, unsigned short opword);
void m68k_do_ROXR_m(struct emu68k_context *context, unsigned short opword);
void m68k_do_alinetrap(struct emu68k_context *context, unsigned short opword);
void m68k_do_flinetrap(struct emu68k_context *context, unsigned short opword);
void m68k_do_unimp(struct emu68k_context *context, unsigned short opword);

struct m68k_instr {
    unsigned short mask;
    unsigned short pattern;
    m68k_instr_handler handler;
};

struct m68k_instr *m68k_instrs[16] = {
    m68k_grp_0, m68k_grp_1, m68k_grp_2, m68k_grp_3,
    m68k_grp_4, m68k_grp_5, m68k_grp_6, m68k_grp_7,
    m68k_grp_8, m68k_grp_9, m68k_grp_a, m68k_grp_b,
    m68k_grp_c, m68k_grp_d, m68k_grp_e, m68k_grp_f,
};

struct m68k_instr m68k_grp_0[] = {
    {0x0fc0, 0x0000, m68k_do_ORI_byte},
    {0x0fc0, 0x0040, m68k_do_ORI_word},
    {0x0fc0, 0x0080, m68k_do_ORI_long},
    {0x0fc0, 0x0200, m68k_do_ANDI_byte},
    {0x0fc0, 0x0240, m68k_do_ANDI_word},
    {0x0fc0, 0x0280, m68k_do_ANDI_long},
    {0x0fc0, 0x0800, m68k_do_BTST_stat},
    {0x0fc0, 0x0c00, m68k_do_CMPI_byte},
    {0x0fc0, 0x0c40, m68k_do_CMPI_word},
    {0x0fc0, 0x0c80, m68k_do_CMPI_long},
    {0x01c0, 0x0100, m68k_do_BTST_dyn},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_1[] = {
    {0x0000, 0x0000, m68k_do_MOVE_byte},
};

struct m68k_instr m68k_grp_2[] = {
    {0x01c0, 0x0040, m68k_do_MOVEA_long},
    {0x0000, 0x0000, m68k_do_MOVE_long},
};

struct m68k_instr m68k_grp_3[] = {
    {0x01c0, 0x0040, m68k_do_MOVEA_word},
    {0x0000, 0x0000, m68k_do_MOVE_word},
};

struct m68k_instr m68k_grp_4[] = {
    {0x0fff, 0x0e71, m68k_do_NOP},
    {0x0fff, 0x0e75, m68k_do_RTS},
    {0x0ff8, 0x0e50, m68k_do_LINK},
    {0x0ff8, 0x0e58, m68k_do_UNLK},
    {0x0ff8, 0x0e60, m68k_do_MOVE_to_USP},
    {0x0ff8, 0x0e68, m68k_do_MOVE_from_USP},
    {0x0fc0, 0x00c0, m68k_do_MOVE_from_SR},
    {0x0fc0, 0x0200, m68k_do_CLR_byte},
    {0x0fc0, 0x0240, m68k_do_CLR_word},
    {0x0fc0, 0x0280, m68k_do_CLR_long},
    {0x0fc0, 0x04c0, m68k_do_MOVE_to_CCR},
    {0x0fc0, 0x06c0, m68k_do_MOVE_to_SR},
    {0x0fc0, 0x0880, m68k_do_MOVEM_RM_word},
    {0x0fc0, 0x08c0, m68k_do_MOVEM_RM_long},
    {0x0fc0, 0x0a00, m68k_do_TST_byte},
    {0x0fc0, 0x0a40, m68k_do_TST_word},
    {0x0fc0, 0x0a80, m68k_do_TST_long},
    {0x0fc0, 0x0ac0, m68k_do_TAS},
    {0x0fc0, 0x0c80, m68k_do_MOVEM_MR_word},
    {0x0fc0, 0x0cc0, m68k_do_MOVEM_MR_long},
    {0x0fc0, 0x0e80, m68k_do_JSR},
    {0x0fc0, 0x0ec0, m68k_do_JMP},
    {0x01c0, 0x01c0, m68k_do_LEA},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_5[] = {
    /* FIXME: DBcc instructions come first */
    {0x0ff8, 0x01c8, m68k_do_DBF},
    {0x0fc0, 0x01c0, m68k_do_SF},
    {0x01c0, 0x0000, m68k_do_ADDQ_byte},
    {0x01c0, 0x0040, m68k_do_ADDQ_word},
    {0x01c0, 0x0080, m68k_do_ADDQ_long},
    {0x01c0, 0x0100, m68k_do_SUBQ_byte},
    {0x01c0, 0x0140, m68k_do_SUBQ_word},
    {0x01c0, 0x0180, m68k_do_SUBQ_long},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_6[] = {
    {0x0f00, 0x0000, m68k_do_BRA},
    {0x0f00, 0x0100, m68k_do_BSR},
    {0x0f00, 0x0400, m68k_do_BCC},
    {0x0f00, 0x0500, m68k_do_BCS},
    {0x0f00, 0x0600, m68k_do_BNE},
    {0x0f00, 0x0700, m68k_do_BEQ},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_7[] = {
    {0x0100, 0x0000, m68k_do_MOVEQ},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_8[] = {
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_9[] = {
    {0x01c0, 0x00c0, m68k_do_SUBA_word},
    {0x01c0, 0x01c0, m68k_do_SUBA_long},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_a[] = {
    {0x0000, 0x0000, m68k_do_alinetrap},
};

struct m68k_instr m68k_grp_b[] = {
    {0x01c0, 0x0000, m68k_do_CMP_byte},
    {0x01c0, 0x0040, m68k_do_CMP_word},
    {0x01c0, 0x0080, m68k_do_CMP_long},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_c[] = {
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_d[] = {
    {0x01c0, 0x0000, m68k_do_ADD_d_byte},
    {0x01c0, 0x0040, m68k_do_ADD_d_word},
    {0x01c0, 0x0080, m68k_do_ADD_d_long},
    {0x01c0, 0x0100, m68k_do_ADD_e_byte},
    {0x01c0, 0x0140, m68k_do_ADD_e_word},
    {0x01c0, 0x0180, m68k_do_ADD_e_long},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_e[] = {
    {0x1d8, 0x0000, m68k_do_ASR_r_byte},
    {0x1d8, 0x0040, m68k_do_ASR_r_word},
    {0x1d8, 0x0080, m68k_do_ASR_r_long},
    {0xfc0, 0x00c0, m68k_do_ASR_m},
    {0x1d8, 0x0100, m68k_do_LSL_r_byte}, /* ASL */
    {0x1d8, 0x0140, m68k_do_LSL_r_word}, /* ASL */
    {0x1d8, 0x0180, m68k_do_LSL_r_long}, /* ASL */
    {0xfc0, 0x01c0, m68k_do_LSL_m}, /* ASL */
    {0x1d8, 0x0008, m68k_do_LSR_r_byte},
    {0x1d8, 0x0048, m68k_do_LSR_r_word},
    {0x1d8, 0x0088, m68k_do_LSR_r_long},
    {0xfc0, 0x02c0, m68k_do_LSR_m},
    {0x1d8, 0x0108, m68k_do_LSL_r_byte},
    {0x1d8, 0x0148, m68k_do_LSL_r_word},
    {0x1d8, 0x0188, m68k_do_LSL_r_long},
    {0xfc0, 0x03c0, m68k_do_LSL_m},
    {0x1d8, 0x0010, m68k_do_ROXR_r_byte},
    {0x1d8, 0x0050, m68k_do_ROXR_r_word},
    {0x1d8, 0x0090, m68k_do_ROXR_r_long},
    {0xfc0, 0x04c0, m68k_do_ROXR_m},
    {0x1d8, 0x0110, m68k_do_ROXL_r_byte},
    {0x1d8, 0x0150, m68k_do_ROXL_r_word},
    {0x1d8, 0x0190, m68k_do_ROXL_r_long},
    {0xfc0, 0x05c0, m68k_do_ROXL_m},
    {0x1d8, 0x0018, m68k_do_ROR_r_byte},
    {0x1d8, 0x0058, m68k_do_ROR_r_word},
    {0x1d8, 0x0098, m68k_do_ROR_r_long},
    {0xfc0, 0x06c0, m68k_do_ROR_m},
    {0x1d8, 0x0118, m68k_do_ROL_r_byte},
    {0x1d8, 0x0158, m68k_do_ROL_r_word},
    {0x1d8, 0x0198, m68k_do_ROL_r_long},
    {0xfc0, 0x07c0, m68k_do_ROL_m},
    {0x0000, 0x0000, m68k_do_unimp},
};

struct m68k_instr m68k_grp_f[] = {
    {0x0000, 0x0000, m68k_do_flinetrap},
};

void emu68k_step(struct emu68k_context *context)
{
    unsigned short opword;
    struct m68k_instr *cur_instr;
    
/*     deb_printf("emu68k_step: stepping.\n"); */
    if (context->pc & 1) {
	/* FIXME: bad things happen here */
    }
    opword = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
/*     deb_printf("0x%06x: 0x%04hx.\n", context->pc, opword); */
    context->pc += 2;
    cur_instr = m68k_instrs[opword >> 12];
    while ((opword & cur_instr->mask) != cur_instr->pattern) {
	cur_instr++;
    }
    cur_instr->handler(context, opword);
}

void emu68k_reset(struct emu68k_context *context)
{
    unsigned short tmp1;
    unsigned short tmp2;

    tmp1 = context->read16table[(0x000000 >> context->memshift) & context->memmask](context->cpu, 0x000000);
    tmp2 = context->read16table[(0x000002 >> context->memshift) & context->memmask](context->cpu, 0x000002);

    context->regs_a[7] = (tmp1 << 16) | tmp2;

    tmp1 = context->read16table[(0x000004 >> context->memshift) & context->memmask](context->cpu, 0x000004);
    tmp2 = context->read16table[(0x000006 >> context->memshift) & context->memmask](context->cpu, 0x000006);

    context->flags = 0x2000; /* FIXME: may be wrong */
    
    context->pc = (tmp1 << 16) | tmp2;
}

#define AMT_DATA      0x1
#define AMT_MEMORY    0x2
#define AMT_CONTROL   0x4
#define AMT_ALTERABLE 0x8

struct m68k_amode {
    unsigned char type;
    unsigned long data;
    unsigned long flags;
    int reg;
    struct emu68k_context *context;
    struct m68k_amode_api *api;
};

extern struct m68k_amode_api m68k_amode_api_0;
extern struct m68k_amode_api m68k_amode_api_1;
extern struct m68k_amode_api m68k_amode_api_2;
extern struct m68k_amode_api m68k_amode_api_3;
extern struct m68k_amode_api m68k_amode_api_4;
extern struct m68k_amode_api m68k_amode_api_5;
extern struct m68k_amode_api m68k_amode_api_6;
extern struct m68k_amode_api m68k_amode_api_7;
extern struct m68k_amode_api m68k_amode_api_8;
extern struct m68k_amode_api m68k_amode_api_9;
extern struct m68k_amode_api m68k_amode_api_10;
extern struct m68k_amode_api m68k_amode_api_11;

struct m68k_amode m68k_amodes[] = {
    {0x09, 0, 0, 0, NULL, &m68k_amode_api_0},  /* Dn */
    {0x08, 0, 0, 0, NULL, &m68k_amode_api_1},  /* An */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_2},  /* (An) */
    {0x0b, 0, 0, 0, NULL, &m68k_amode_api_3},  /* (An)+ */
    {0x0b, 0, 0, 0, NULL, &m68k_amode_api_4},  /* -(An) */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_5},  /* d(An) */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_6},  /* d(An,Ri) */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_7},  /* xxxx */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_8},  /* xxxxxxxx */
    {0x07, 0, 0, 0, NULL, &m68k_amode_api_9},  /* d */
    {0x07, 0, 0, 0, NULL, &m68k_amode_api_10}, /* d(Ri) */
    {0x03, 0, 0, 0, NULL, &m68k_amode_api_11}, /* #xxxx */
    {0x00, 0, 0, 0, NULL, NULL},               /* <invalid> */
};

typedef void (*m68k_amode_resolver)(struct m68k_amode *, struct emu68k_context *, int);
typedef unsigned char (*m68k_amode_read_byte)(struct m68k_amode *);
typedef unsigned short (*m68k_amode_read_word)(struct m68k_amode *);
typedef unsigned long (*m68k_amode_read_long)(struct m68k_amode *);
typedef void (*m68k_amode_write_byte)(struct m68k_amode *, unsigned char);
typedef void (*m68k_amode_write_word)(struct m68k_amode *, unsigned short);
typedef void (*m68k_amode_write_long)(struct m68k_amode *, unsigned long);
typedef void (*m68k_amode_after)(struct m68k_amode *);

struct m68k_amode_api {
    m68k_amode_resolver resolve;
    m68k_amode_read_byte readbyte;
    m68k_amode_read_word readword;
    m68k_amode_read_long readlong;
    m68k_amode_write_byte writebyte;
    m68k_amode_write_word writeword;
    m68k_amode_write_long writelong;
    m68k_amode_after after;
};

#define AMS_BOGUS 0
#define AMS_BYTE 1
#define AMS_WORD 2
#define AMS_LONG 3

void m68k_amode_none_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    deb_printf("m68k: unimplemented amode (api: 0x%08x).\n", amode->api);
    system_flags |= F_UNIMPL;
}

void m68k_amode_0_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
}

unsigned char m68k_amode_0_readbyte(struct m68k_amode *amode)
{
    return (unsigned char)amode->context->regs_d[amode->reg];
}

unsigned short m68k_amode_0_readword(struct m68k_amode *amode)
{
    return (unsigned short)amode->context->regs_d[amode->reg];
}

unsigned long m68k_amode_0_readlong(struct m68k_amode *amode)
{
    return amode->context->regs_d[amode->reg];
}

void m68k_amode_0_writebyte(struct m68k_amode *amode, unsigned char data)
{
    (unsigned char)amode->context->regs_d[amode->reg] = data;
}

void m68k_amode_0_writeword(struct m68k_amode *amode, unsigned short data)
{
    (unsigned short)amode->context->regs_d[amode->reg] = data;
}

void m68k_amode_0_writelong(struct m68k_amode *amode, unsigned long data)
{
    amode->context->regs_d[amode->reg] = data;
}

void m68k_amode_0_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_0 = {
    m68k_amode_0_resolve,
    m68k_amode_0_readbyte,
    m68k_amode_0_readword,
    m68k_amode_0_readlong,
    m68k_amode_0_writebyte,
    m68k_amode_0_writeword,
    m68k_amode_0_writelong,
    m68k_amode_0_after,
};

void m68k_amode_1_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
}

unsigned char m68k_amode_1_readbyte(struct m68k_amode *amode)
{
    /* FIXME: signal exception */
    return 0;
}

unsigned short m68k_amode_1_readword(struct m68k_amode *amode)
{
    return (unsigned short)amode->context->regs_a[amode->reg];
}

unsigned long m68k_amode_1_readlong(struct m68k_amode *amode)
{
    return amode->context->regs_a[amode->reg];
}

void m68k_amode_1_writebyte(struct m68k_amode *amode, unsigned char data)
{
    /* FIXME: signal exception */
}

void m68k_amode_1_writeword(struct m68k_amode *amode, unsigned short data)
{
    (unsigned short)amode->context->regs_a[amode->reg] = data;
}

void m68k_amode_1_writelong(struct m68k_amode *amode, unsigned long data)
{
    amode->context->regs_a[amode->reg] = data;
}

void m68k_amode_1_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_1 = {
    m68k_amode_1_resolve,
    m68k_amode_1_readbyte,
    m68k_amode_1_readword,
    m68k_amode_1_readlong,
    m68k_amode_1_writebyte,
    m68k_amode_1_writeword,
    m68k_amode_1_writelong,
    m68k_amode_1_after,
};

void m68k_amode_2_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
    amode->data = context->regs_a[amode->reg];
}

unsigned char m68k_amode_2_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_2_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_2_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_2_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_2_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_2_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_2_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_2 = {
    m68k_amode_2_resolve,
    m68k_amode_2_readbyte,
    m68k_amode_2_readword,
    m68k_amode_2_readlong,
    m68k_amode_2_writebyte,
    m68k_amode_2_writeword,
    m68k_amode_2_writelong,
    m68k_amode_2_after,
};

void m68k_amode_3_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
    amode->data = context->regs_a[amode->reg];
}

unsigned char m68k_amode_3_readbyte(struct m68k_amode *amode)
{
    amode->flags = 1;
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_3_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    amode->flags = 2;
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_3_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    amode->flags = 4;
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_3_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
    amode->flags = 1;
}

void m68k_amode_3_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
    amode->flags = 2;
}

void m68k_amode_3_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
    amode->flags = 4;
}

void m68k_amode_3_after(struct m68k_amode *amode)
{
/*     deb_printf("amode_3_after %d.\n", amode->flags); */
    amode->context->regs_a[amode->reg] += amode->flags;
    amode->data += amode->flags;
}

struct m68k_amode_api m68k_amode_api_3 = {
    m68k_amode_3_resolve,
    m68k_amode_3_readbyte,
    m68k_amode_3_readword,
    m68k_amode_3_readlong,
    m68k_amode_3_writebyte,
    m68k_amode_3_writeword,
    m68k_amode_3_writelong,
    m68k_amode_3_after,
};

void m68k_amode_4_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    /* FIXME: this may not do the right thing for MOVE.L A7, -(A7) */
    amode->context = context;
    if ((size == AMS_BYTE) || (size == AMS_WORD)) {
	amode->flags = 2;
    } else if (size == AMS_LONG) {
	amode->flags = 4;
    } else {
	deb_printf("m68k: BUG: bogus size passed to amode 4.\n");
    }
    amode->data = context->regs_a[amode->reg] - amode->flags;
}

unsigned char m68k_amode_4_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_4_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_4_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_4_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_4_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_4_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_4_after(struct m68k_amode *amode)
{
    amode->context->regs_a[amode->reg] -= amode->flags;
    amode->data = amode->context->regs_a[amode->reg] - amode->flags;
}

struct m68k_amode_api m68k_amode_api_4 = {
    m68k_amode_4_resolve,
    m68k_amode_4_readbyte,
    m68k_amode_4_readword,
    m68k_amode_4_readlong,
    m68k_amode_4_writebyte,
    m68k_amode_4_writeword,
    m68k_amode_4_writelong,
    m68k_amode_4_after,
};

void m68k_amode_5_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    signed short data;
    
    amode->context = context;
    amode->data = context->regs_a[amode->reg];

    data = amode->context->read16table[(amode->context->pc >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->context->pc);
    amode->context->pc += 2;

    amode->data += (signed long)data;
}

unsigned char m68k_amode_5_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_5_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_5_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_5_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_5_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_5_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_5_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_5 = {
    m68k_amode_5_resolve,
    m68k_amode_5_readbyte,
    m68k_amode_5_readword,
    m68k_amode_5_readlong,
    m68k_amode_5_writebyte,
    m68k_amode_5_writeword,
    m68k_amode_5_writelong,
    m68k_amode_5_after,
};

void m68k_amode_6_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    signed short data;

    amode->context = context;
    amode->data = context->regs_a[amode->reg];

    data = amode->context->read16table[(amode->context->pc >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->context->pc);
    amode->context->pc += 2;

    amode->data += (signed char)data;
    if (data & 0x0800) {
	if (data & 0x8000) {
	    /* A.L */
	    amode->data += amode->context->regs_a[(data >> 12) & 7];
	} else {
	    /* D.L */
	    amode->data += amode->context->regs_d[(data >> 12) & 7];
	}
    } else {
	if (data & 0x8000) {
	    /* A.W */
	    amode->data += (signed short)amode->context->regs_a[(data >> 12) & 7];
	} else {
	    /* D.W */
	    amode->data += (signed short)amode->context->regs_d[(data >> 12) & 7];
	}
    }
}

unsigned char m68k_amode_6_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_6_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_6_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_6_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_6_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_6_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_6_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_6 = {
    m68k_amode_6_resolve,
    m68k_amode_6_readbyte,
    m68k_amode_6_readword,
    m68k_amode_6_readlong,
    m68k_amode_6_writebyte,
    m68k_amode_6_writeword,
    m68k_amode_6_writelong,
    m68k_amode_6_after,
};

void m68k_amode_7_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    short tmp;
    
    amode->context = context;

    tmp = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    amode->data = tmp; /* FIXME: make sure that this sign-extends */
/*     deb_printf("amode7: 0x%04hx, 0x%06x.\n", tmp, amode->data & 0xffffff); */
}

unsigned char m68k_amode_7_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_7_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_7_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_7_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_7_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_7_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_7_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_7 = {
    m68k_amode_7_resolve,
    m68k_amode_7_readbyte,
    m68k_amode_7_readword,
    m68k_amode_7_readlong,
    m68k_amode_7_writebyte,
    m68k_amode_7_writeword,
    m68k_amode_7_writelong,
    m68k_amode_7_after,
};

void m68k_amode_8_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    unsigned short tmp1;
    unsigned short tmp2;
    
    amode->context = context;

    tmp1 = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;
    tmp2 = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    amode->data = (tmp1 << 16) | tmp2;
}

unsigned char m68k_amode_8_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_8_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_8_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_8_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_8_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_8_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_8_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_8 = {
    m68k_amode_8_resolve,
    m68k_amode_8_readbyte,
    m68k_amode_8_readword,
    m68k_amode_8_readlong,
    m68k_amode_8_writebyte,
    m68k_amode_8_writeword,
    m68k_amode_8_writelong,
    m68k_amode_8_after,
};

void m68k_amode_9_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    signed short data;
    
    amode->context = context;
    amode->data = context->pc; /* FIXME: may be too small by 2 */

    data = amode->context->read16table[(amode->context->pc >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->context->pc);
    amode->context->pc += 2;

    amode->data += (signed long)data;
}

unsigned char m68k_amode_9_readbyte(struct m68k_amode *amode)
{
    return amode->context->read8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned short m68k_amode_9_readword(struct m68k_amode *amode)
{
    /* FIXME: Illegal Address? */
    return amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
}

unsigned long m68k_amode_9_readlong(struct m68k_amode *amode)
{
    unsigned short tmpval1;
    unsigned short tmpval2;
    
    /* FIXME: Illegal Address? */
    tmpval1 = amode->context->read16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data);
    tmpval2 = amode->context->read16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2));
    return (tmpval1 << 16) | tmpval2;
}

void m68k_amode_9_writebyte(struct m68k_amode *amode, unsigned char data)
{
    amode->context->write8table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_9_writeword(struct m68k_amode *amode, unsigned short data)
{
    /* FIXME: Illegal Address? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data);
}

void m68k_amode_9_writelong(struct m68k_amode *amode, unsigned long data)
{
    /* FIXME: Illegal Address? */
    /* FIXME: Is the high or the low word supposed to come first? */
    amode->context->write16table[(amode->data >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->data, data >> 16);
    amode->context->write16table[((amode->data + 2) >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, (amode->data + 2), data & 0xffff);
}

void m68k_amode_9_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_9 = {
    m68k_amode_9_resolve,
    m68k_amode_9_readbyte,
    m68k_amode_9_readword,
    m68k_amode_9_readlong,
    m68k_amode_9_writebyte,
    m68k_amode_9_writeword,
    m68k_amode_9_writelong,
    m68k_amode_9_after,
};

struct m68k_amode_api m68k_amode_api_10 = {
    m68k_amode_none_resolve,
    m68k_amode_2_readbyte,
    m68k_amode_2_readword,
    m68k_amode_2_readlong,
    m68k_amode_2_writebyte,
    m68k_amode_2_writeword,
    m68k_amode_2_writelong,
    m68k_amode_2_after,
};

void m68k_amode_11_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    unsigned short tmp1;
    unsigned short tmp2;
    
    amode->context = context;

    if (size == AMS_BYTE) {
	tmp1 = 0;
	tmp2 = 0;
    } else if (size == AMS_WORD) {
	tmp2 = amode->context->read16table[(amode->context->pc >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->context->pc);
	amode->context->pc += 2;
	tmp1 = 0;
    } else if (size == AMS_LONG) {
	tmp1 = amode->context->read16table[(amode->context->pc >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->context->pc);
	amode->context->pc += 2;
	tmp2 = amode->context->read16table[(amode->context->pc >> amode->context->memshift) & amode->context->memmask](amode->context->cpu, amode->context->pc);
	amode->context->pc += 2;
    } else {
	deb_printf("m68k: BUG: amode 11 reports illegal size %d.\n", size);
	tmp1 = 0;
	tmp2 = 0;
    }
    amode->data = (tmp1 << 16) | tmp2;
}

unsigned char m68k_amode_11_readbyte(struct m68k_amode *amode)
{
    deb_printf("m68k: byte read of immediate not currently supported.\n");
    return 0;
}

unsigned short m68k_amode_11_readword(struct m68k_amode *amode)
{
/*     deb_printf("m68k: #xxxx. pc 0x%06x.\n", amode->context->pc); */

    return amode->data;
}

unsigned long m68k_amode_11_readlong(struct m68k_amode *amode)
{
/*     deb_printf("m68k: #xxxxxxxx 0x%08x.\n", amode->data); */

    return amode->data;
}

void m68k_amode_11_writebyte(struct m68k_amode *amode, unsigned char data)
{
    deb_printf("m68k: CPU BUG: Write to non-alterable.\n");
    abort();
}

void m68k_amode_11_writeword(struct m68k_amode *amode, unsigned short data)
{
    deb_printf("m68k: CPU BUG: Write to non-alterable.\n");
    abort();
}

void m68k_amode_11_writelong(struct m68k_amode *amode, unsigned long data)
{
    deb_printf("m68k: CPU BUG: Write to non-alterable.\n");
    abort();
}

void m68k_amode_11_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_11 = {
    m68k_amode_11_resolve,
    m68k_amode_11_readbyte,
    m68k_amode_11_readword,
    m68k_amode_11_readlong,
    m68k_amode_11_writebyte,
    m68k_amode_11_writeword,
    m68k_amode_11_writelong,
    m68k_amode_11_after,
};

struct m68k_amode m68k_get_src_amode(unsigned short opword)
{
    struct m68k_amode retval;
    
    if ((opword & 0x38) == 0x38) {
	if ((opword & 7) > 4) {
	    retval = m68k_amodes[12];
	} else {
	    retval = m68k_amodes[7 + (opword & 7)];
	}
    } else {
	retval = m68k_amodes[(opword & 0x38) >> 3];
    }
    retval.reg = opword & 7;
    return retval;
}

struct m68k_amode m68k_get_dest_amode(unsigned short opword)
{
    struct m68k_amode retval;
    
    if ((opword & 0x1c0) == 0x1c0) {
	if ((opword & 0xe00) > 0x800) {
	    retval = m68k_amodes[12];
	} else {
	    retval = m68k_amodes[7 + ((opword & 0xe00) >> 9)];
	}
    } else {
	retval = m68k_amodes[(opword & 0x1c0) >> 6];
    }
    retval.reg = (opword & 0xe00) >> 9;
    return retval;
}

void m68k_push_long(struct emu68k_context *context, unsigned long data)
{
    /* FIXME: addresses on stack may be wrong */
    /* FIXME: data may be written in wrong order */
    context->regs_a[7] -= 4;
    context->write16table[((context->regs_a[7] + 2) >> context->memshift) & context->memmask](context->cpu, context->regs_a[7] + 2, data & 0xffff);
    context->write16table[((context->regs_a[7]) >> context->memshift) & context->memmask](context->cpu, context->regs_a[7], data  >> 16);
}

unsigned long m68k_pop_long(struct emu68k_context *context)
{
    unsigned short tmp1;
    unsigned short tmp2;

    tmp1 = context->read16table[(context->regs_a[7] >> context->memshift) & context->memmask](context->cpu, context->regs_a[7]);
    tmp2 = context->read16table[((context->regs_a[7] + 2) >> context->memshift) & context->memmask](context->cpu, (context->regs_a[7] + 2));

    context->regs_a[7] += 4;
    
    return (tmp1 << 16) | tmp2;
}

#define FLAG_NZ_byte(context, data) {context->flags &= 0xfff0; if (!data) {context->flags |= 4;} if (data & 0x80) {context->flags |= 8;}}
#define FLAG_NZ_word(context, data) {context->flags &= 0xfff0; if (!data) {context->flags |= 4;} if (data & 0x8000) {context->flags |= 8;}}
#define FLAG_NZ_long(context, data) {context->flags &= 0xfff0; if (!data) {context->flags |= 4;} if (data & 0x80000000) {context->flags |= 8;}}

/* FIXME: I don't understand these next few macros */

#define FLAG_VC_ADD_byte(context, dest, src1, src2) {if (dest < src1) {context->flags |= 1;} if (((dest) ^ (src1)) & ((dest) ^ (src2)) & 0x80) {context->flags |= 2;}}
#define FLAG_VC_ADD_word(context, dest, src1, src2) {if (dest < src1) {context->flags |= 1;} if (((dest) ^ (src1)) & ((dest) ^ (src2)) & 0x8000) {context->flags |= 2;}}
#define FLAG_VC_ADD_long(context, dest, src1, src2) {if (dest < src1) {context->flags |= 1;} if (((dest) ^ (src1)) & ((dest) ^ (src2)) & 0x80000000) {context->flags |= 2;}}

#define FLAG_VC_SUB_byte(context, dest, src1, src2) {if (src1 > src2) {context->flags |= 1;} if (((dest) ^ (src1)) & ((src1) ^ (src2)) & 0x80) {context->flags |= 2;}}
#define FLAG_VC_SUB_word(context, dest, src1, src2) {if (src1 > src2) {context->flags |= 1;} if (((dest) ^ (src1)) & ((src1) ^ (src2)) & 0x8000) {context->flags |= 2;}}
#define FLAG_VC_SUB_long(context, dest, src1, src2) {if (src1 > src2) {context->flags |= 1;} if (((dest) ^ (src1)) & ((src1) ^ (src2)) & 0x80000000) {context->flags |= 2;}}

void m68k_do_unimp(struct emu68k_context *context, unsigned short opword)
{
    deb_printf("emu68k: unimplimented opcode 0x%04hx at 0x%06x.\n", opword, context->pc);
    system_flags |= F_UNIMPL;
    /* FIXME: signal invalid opcode */
}

void m68k_do_alinetrap(struct emu68k_context *context, unsigned short opword)
{
    deb_printf("emu68k: A-Line trap 0x%04hx at 0x%06x.\n", opword, context->pc);
    /* FIXME: signal a-line trap */
}

void m68k_do_flinetrap(struct emu68k_context *context, unsigned short opword)
{
    deb_printf("emu68k: F-Line trap 0x%04hx at 0x%06x.\n", opword, context->pc);
    /* FIXME: signal f-line trap */
}

void m68k_do_ANDI_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_BYTE);
	data2 = src.api->readbyte(&src);
	src.api->after(&src);
	data3 = data2 & data;
	src.api->writebyte(&src, data3);
	FLAG_NZ_byte(context, data3);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ANDI_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	data2 = src.api->readword(&src);
	src.api->after(&src);
	data3 = data2 & data;
	src.api->writeword(&src, data3);
	FLAG_NZ_word(context, data3);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ANDI_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc) << 16;
    context->pc += 2;
    data |= context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc) & 0xffff;
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_LONG);
	data2 = src.api->readlong(&src);
	src.api->after(&src);
	data3 = data2 & data;
	src.api->writelong(&src, data3);
	FLAG_NZ_long(context, data3);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ORI_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_BYTE);
	data2 = src.api->readbyte(&src);
	src.api->after(&src);
	data3 = data2 | data;
	src.api->writebyte(&src, data3);
	FLAG_NZ_byte(context, data3);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ORI_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	data2 = src.api->readword(&src);
	src.api->after(&src);
	data3 = data2 | data;
	src.api->writeword(&src, data3);
	FLAG_NZ_word(context, data3);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ORI_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc) << 16;
    context->pc += 2;
    data |= context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc) & 0xffff;
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_LONG);
	data2 = src.api->readlong(&src);
	src.api->after(&src);
	data3 = data2 | data;
	src.api->writelong(&src, data3);
	FLAG_NZ_long(context, data3);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CMPI_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_BYTE);
	data2 = src.api->readbyte(&src);
	src.api->after(&src);
	data3 = data2 - data;
	FLAG_NZ_byte(context, data3);
	FLAG_VC_SUB_byte(context, data3, data2, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CMPI_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;

/*     deb_printf("CMPI_word.\n"); */
    
    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_WORD);
	data2 = src.api->readword(&src);
	src.api->after(&src);
	data3 = data2 - data;
	FLAG_NZ_word(context, data3);
	FLAG_VC_SUB_word(context, data3, data2, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CMPI_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    struct m68k_amode src;

    data = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc) << 16;
    context->pc += 2;
    data |= context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc) & 0xffff;
    context->pc += 2;

    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_LONG);
	data2 = src.api->readlong(&src);
	src.api->after(&src);
	data3 = data2 - data;
	FLAG_NZ_long(context, data3);
	FLAG_VC_SUB_long(context, data3, data2, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVE_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    unsigned char data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword);

    if (((dest.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) && (src.type)) {
	src.api->resolve(&src, context, AMS_BYTE);
	dest.api->resolve(&dest, context, AMS_BYTE);
	data = src.api->readbyte(&src);
	dest.api->writebyte(&dest, data);
	src.api->after(&src);
	dest.api->after(&dest);
	FLAG_NZ_byte(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVE_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    unsigned short data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword);

    if (((dest.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) && (src.type)) {
	src.api->resolve(&src, context, AMS_WORD);
	dest.api->resolve(&dest, context, AMS_WORD);
	data = src.api->readword(&src);
	dest.api->writeword(&dest, data);
	src.api->after(&src);
	dest.api->after(&dest);
	FLAG_NZ_word(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEA_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    unsigned short data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword); /* Guaranteed to be An */

    if (src.type) {
	src.api->resolve(&src, context, AMS_WORD);
	dest.api->resolve(&dest, context, AMS_WORD);
	data = src.api->readword(&src);
	dest.api->writeword(&dest, data);
	src.api->after(&src);
	dest.api->after(&dest);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVE_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    unsigned long data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword);

    if (((dest.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) && (src.type)) {
	src.api->resolve(&src, context, AMS_LONG);
	dest.api->resolve(&dest, context, AMS_LONG);
	data = src.api->readlong(&src);
	dest.api->writelong(&dest, data);
	src.api->after(&src);
	dest.api->after(&dest);
	FLAG_NZ_long(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEA_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    unsigned long data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword); /* Guaranteed to be An */

    if (src.type) {
	src.api->resolve(&src, context, AMS_LONG);
	dest.api->resolve(&dest, context, AMS_LONG);
	data = src.api->readlong(&src);
	dest.api->writelong(&dest, data);
	src.api->after(&src);
	dest.api->after(&dest);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CLR_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_BYTE);
	src.api->writebyte(&src, 0);
	src.api->after(&src);
	FLAG_NZ_byte(context, 0);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CLR_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	src.api->writeword(&src, 0);
	src.api->after(&src);
	FLAG_NZ_word(context, 0);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CLR_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_LONG);
	src.api->writelong(&src, 0);
	src.api->after(&src);
	FLAG_NZ_long(context, 0);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_TST_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_BYTE);
	data = src.api->readbyte(&src);
	src.api->after(&src);
	FLAG_NZ_byte(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_TST_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_WORD);
	data = src.api->readword(&src);
	src.api->after(&src);
	FLAG_NZ_word(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_TST_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_LONG);
	data = src.api->readlong(&src);
	src.api->after(&src);
	FLAG_NZ_long(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_TAS(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_BYTE);
	data = src.api->readbyte(&src);
	src.api->writebyte(&src, data | 0x80);
	src.api->after(&src);
	FLAG_NZ_byte(context, data);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_BRA(struct emu68k_context *context, unsigned short opword)
{
    short offset;
    
    if (opword & 0xff) {
	offset = ((signed char)opword);
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    }
    context->pc += offset;
}

void m68k_do_BSR(struct emu68k_context *context, unsigned short opword)
{
    short offset;

    if (opword & 0xff) {
	offset = ((signed char)opword);

	m68k_push_long(context, context->pc);
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);

	m68k_push_long(context, context->pc + 2);
    }
    
    context->pc += offset;
}

void m68k_do_BCC(struct emu68k_context *context, unsigned short opword)
{
    short offset;
    unsigned long saved_pc;

    saved_pc = context->pc;
    
    if (opword & 0xff) {
	offset = ((signed char)opword);
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
    }
    if (!(context->flags & 0x01)) {
	context->pc = saved_pc + offset;
    }
}

void m68k_do_BCS(struct emu68k_context *context, unsigned short opword)
{
    short offset;
    unsigned long saved_pc;

    saved_pc = context->pc;
    
    if (opword & 0xff) {
	offset = ((signed char)opword);
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
    }
    if ((context->flags & 0x01)) {
	context->pc = saved_pc + offset;
    }
}

void m68k_do_BNE(struct emu68k_context *context, unsigned short opword)
{
    short offset;
    unsigned long saved_pc;

    saved_pc = context->pc;
    
    if (opword & 0xff) {
	offset = ((signed char)opword);
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
    }
    if (!(context->flags & 0x04)) {
	context->pc = saved_pc + offset;
    }
}

void m68k_do_BEQ(struct emu68k_context *context, unsigned short opword)
{
    short offset;
    unsigned long saved_pc;

    saved_pc = context->pc;
    
    if (opword & 0xff) {
	offset = ((signed char)opword);
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
    }
    if ((context->flags & 0x04)) {
	context->pc = saved_pc + offset;
    }
}

void m68k_do_LEA(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_CONTROL) {
	src.api->resolve(&src, context, AMS_BOGUS);
	context->regs_a[(opword >> 9) & 7] = src.data;
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEQ(struct emu68k_context *context, unsigned short opword)
{
    long data;
    
    data = (signed char)(opword & 0xff); /* NOTE: this had better work */
    context->regs_d[(opword >> 9) & 7] = data;
}

void m68k_do_DBF(struct emu68k_context *context, unsigned short opword)
{
    short offset;
    
    ((unsigned short)context->regs_d[opword & 7])--;
    if (((unsigned short)context->regs_d[opword & 7]) == 0xffff) {
	context->pc += 2;
    } else {
	offset = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	/* FIXME: do we need to add 2 here? */
	context->pc += offset;
    }
}

void m68k_do_SF(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_BYTE);
	src.api->writebyte(&src, 0);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_BTST_dyn(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short tmp;
    unsigned long data;

    tmp = context->regs_d[(opword >> 9) & 7];
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	if (src.api == &m68k_amode_api_0) {
	    src.api->resolve(&src, context, AMS_LONG);
	    data = src.api->readlong(&src);
	    tmp &= 0x1f;
	} else {
	    src.api->resolve(&src, context, AMS_BYTE);
	    data = src.api->readbyte(&src);
	    tmp &= 7;
	}
	src.api->after(&src);
	if (data & (1 << tmp)) {
	    context->flags &= ~4;
	} else {
	    context->flags |= 4;
	}
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_BTST_stat(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short tmp;
    unsigned long data;

    tmp = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;
    /* FIXME: signal error if top 8 bits != 0? */
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	if (src.api == &m68k_amode_api_0) {
	    src.api->resolve(&src, context, AMS_LONG);
	    data = src.api->readlong(&src);
	    tmp &= 0x1f;
	} else {
	    src.api->resolve(&src, context, AMS_BYTE);
	    data = src.api->readbyte(&src);
	    tmp &= 7;
	}
	src.api->after(&src);
	if (data & (1 << tmp)) {
	    context->flags &= ~4;
	} else {
	    context->flags |= 4;
	}
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_SUBA_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    short data;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_WORD);
	data = src.api->readword(&src);
	src.api->after(&src);
	context->regs_a[(opword >> 9) & 7] -= data;
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_SUBA_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_LONG);
	data = src.api->readlong(&src);
	src.api->after(&src);
	context->regs_a[(opword >> 9) & 7] -= data;
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_SUBQ_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
	src.api->resolve(&src, context, AMS_BYTE);
	data2 = src.api->readbyte(&src);
	data3 = data2 - data;
	FLAG_NZ_byte(context, data3);
	FLAG_VC_SUB_byte(context, data3, data2, data);
	src.api->writebyte(&src, data3);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_SUBQ_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_ALTERABLE) { /* FIXME: An mode may want to be long */
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
	src.api->resolve(&src, context, AMS_WORD);
	data2 = src.api->readword(&src);
	data3 = data2 - data;
	FLAG_NZ_word(context, data3);
	FLAG_VC_SUB_word(context, data3, data2, data);
	src.api->writeword(&src, data3);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_SUBQ_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_ALTERABLE) {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
	src.api->resolve(&src, context, AMS_LONG);
	data2 = src.api->readlong(&src);
	data3 = data2 - data;
	FLAG_NZ_long(context, data3);
	FLAG_VC_SUB_long(context, data3, data2, data);
	src.api->writelong(&src, data3);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADDQ_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
	src.api->resolve(&src, context, AMS_BYTE);
	data2 = src.api->readbyte(&src);
	data3 = data2 + data;
	FLAG_NZ_byte(context, data3);
	FLAG_VC_ADD_byte(context, data3, data2, data);
	src.api->writebyte(&src, data3);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADDQ_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_ALTERABLE) { /* FIXME: An mode may want to be long */
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
	src.api->resolve(&src, context, AMS_WORD);
	data2 = src.api->readword(&src);
	data3 = data2 + data;
	FLAG_NZ_word(context, data3);
	FLAG_VC_ADD_word(context, data3, data2, data);
	src.api->writeword(&src, data3);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADDQ_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_ALTERABLE) {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
	src.api->resolve(&src, context, AMS_LONG);
	data2 = src.api->readlong(&src);
	data3 = data2 + data;
	FLAG_NZ_long(context, data3);
	FLAG_VC_ADD_long(context, data3, data2, data);
	src.api->writelong(&src, data3);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVE_to_CCR(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    
    src = m68k_get_src_amode(opword);
    
    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_WORD);
	data = src.api->readword(&src);
	src.api->after(&src);
	
	(unsigned char)context->flags = (unsigned char)data;
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVE_to_SR(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;

    if (context->flags & 0x2000) {
	src = m68k_get_src_amode(opword);

	if (src.type & AMT_DATA) {
	    src.api->resolve(&src, context, AMS_WORD);
	    data = src.api->readword(&src);
	    src.api->after(&src);
/* 	    deb_printf("m68k_do_MOVE_to_SR: moving 0x%04hx.\n", data); */
	    context->flags = data;
	    if (!(data & 0x2000)) {
		unsigned long data2;
		data2 = context->regs_a[7];
		context->regs_a[7] = context->other_sp;
		context->other_sp = data2;
	    }
	} else {
	    deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	    /* FIXME: signal invalid amode */
	}
    } else {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_to_SR(): TRAP!\n");
    }
}

void m68k_do_MOVE_from_SR(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_DATA | AMT_ALTERABLE)) == (AMT_DATA | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	src.api->writeword(&src, context->flags);
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEM_RM_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short reglist;
    unsigned short data;
    int i;
    
    src = m68k_get_src_amode(opword);

    if (((src.type & (AMT_CONTROL | AMT_ALTERABLE)) == (AMT_CONTROL | AMT_ALTERABLE)) || (src.api == &m68k_amode_api_4)) {
	reglist = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
	src.api->resolve(&src, context, AMS_WORD);
	if (src.api == &m68k_amode_api_4) {
	    for (i = 0; i < 16; i++) {
		if (reglist & (1 << i)) {
		    if (i & 8) {
			data = context->regs_d[(7 - i) & 7];
		    } else {
			data = context->regs_a[(7 - i) & 7];
		    }
		    src.api->writeword(&src, data);
		    src.api->after(&src);
		}
	    }
	} else {
	    for (i = 0; i < 16; i++) {
		if (reglist & (1 << i)) {
		    if (i & 8) {
			data = context->regs_a[i & 7];
		    } else {
			data = context->regs_d[i & 7];
		    }
		    src.api->writeword(&src, data);
		    src.api->after(&src);
		}
	    }
	}
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEM_RM_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned short reglist;
    int i;

    src = m68k_get_src_amode(opword);

    if (((src.type & (AMT_CONTROL | AMT_ALTERABLE)) == (AMT_CONTROL | AMT_ALTERABLE)) || (src.api == &m68k_amode_api_4)) {
	reglist = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
	src.api->resolve(&src, context, AMS_LONG);
	if (src.api == &m68k_amode_api_4) {
	    for (i = 0; i < 16; i++) {
		if (reglist & (1 << i)) {
		    if (i & 8) {
			data = context->regs_d[(7 - i) & 7];
		    } else {
			data = context->regs_a[(7 - i) & 7];
		    }
		    src.api->writelong(&src, data);
		    src.api->after(&src);
		}
	    }
	} else {
	    for (i = 0; i < 16; i++) {
		if (reglist & (1 << i)) {
		    if (i & 8) {
			data = context->regs_a[i & 7];
		    } else {
			data = context->regs_d[i & 7];
		    }
		    src.api->writelong(&src, data);
		    src.api->after(&src);
		}
	    }
	}
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEM_MR_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    short data;
    unsigned short reglist;
    int i;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & AMT_CONTROL) || (src.api == &m68k_amode_api_3)) {
	reglist = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
	src.api->resolve(&src, context, AMS_WORD);
	for (i = 0; i < 16; i++) {
	    if (reglist & (1 << i)) {
		data = src.api->readword(&src);
		if (i & 8) {
		    context->regs_a[i & 7] = data;
		} else {
		    context->regs_d[i & 7] = data;
		}
		src.api->after(&src);
	    }
	}
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVEM_MR_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned short reglist;
    int i;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & AMT_CONTROL) || (src.api == &m68k_amode_api_3)) {
	reglist = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
	context->pc += 2;
	src.api->resolve(&src, context, AMS_LONG);
	for (i = 0; i < 16; i++) {
	    if (reglist & (1 << i)) {
		data = src.api->readlong(&src);
		if (i & 8) {
		    context->regs_a[i & 7] = data;
		} else {
		    context->regs_d[i & 7] = data;
		}
		src.api->after(&src);
	    }
	}
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_MOVE_to_USP(struct emu68k_context *context, unsigned short opword)
{
    if (context->flags & 0x2000) {
	context->other_sp = context->regs_a[opword & 7];
    } else {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_to_USP(): TRAP!\n");
    }
}

void m68k_do_MOVE_from_USP(struct emu68k_context *context, unsigned short opword)
{
    if (context->flags & 0x2000) {
	context->regs_a[opword & 7] = context->other_sp;
    } else {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_from_USP(): TRAP!\n");
    }
}

void m68k_do_ADD_d_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_BYTE);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readbyte(&src);
	data3 = data2 + data;
	FLAG_NZ_byte(context, data3);
	FLAG_VC_ADD_byte(context, data3, data2, data);
	/* FIXME: X flag? */
	context->regs_d[(opword >> 9) & 7] &= 0xffffff00;
	context->regs_d[(opword >> 9) & 7] |= data3;
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADD_d_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_WORD);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readword(&src);
	data3 = data2 + data;
	FLAG_NZ_word(context, data3);
	FLAG_VC_ADD_word(context, data3, data2, data);
	/* FIXME: X flag? */
	context->regs_d[(opword >> 9) & 7] &= 0xffff0000;
	context->regs_d[(opword >> 9) & 7] |= data3;
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADD_d_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_LONG);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readlong(&src);
	data3 = data2 + data;
	FLAG_NZ_long(context, data3);
	FLAG_VC_ADD_long(context, data3, data2, data);
	/* FIXME: X flag? */
	context->regs_d[(opword >> 9) & 7] = data3;
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADD_e_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_BYTE);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readbyte(&src);
	data3 = data2 + data;
	FLAG_NZ_byte(context, data3);
	FLAG_VC_ADD_byte(context, data3, data2, data);
	/* FIXME: X flag? */
	src.api->writebyte(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADD_e_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_WORD);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readword(&src);
	data3 = data2 + data;
	FLAG_NZ_word(context, data3);
	FLAG_VC_ADD_word(context, data3, data2, data);
	/* FIXME: X flag? */
	src.api->writeword(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ADD_e_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_LONG);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readlong(&src);
	data3 = data2 + data;
	FLAG_NZ_long(context, data3);
	FLAG_VC_ADD_long(context, data3, data2, data);
	/* FIXME: X flag? */
	src.api->writelong(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_RTS(struct emu68k_context *context, unsigned short opword)
{
    context->pc = m68k_pop_long(context);
}

void m68k_do_NOP(struct emu68k_context *context, unsigned short opword)
{
}

void m68k_do_JMP(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_CONTROL) {
	src.api->resolve(&src, context, AMS_BOGUS);
	context->pc = src.data;
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_JSR(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_CONTROL) {
	src.api->resolve(&src, context, AMS_BOGUS);
	m68k_push_long(context, context->pc);
	context->pc = src.data;
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_LINK(struct emu68k_context *context, unsigned short opword)
{
    signed short tmp;

    tmp = context->read16table[(context->pc >> context->memshift) & context->memmask](context->cpu, context->pc);
    context->pc += 2;

    m68k_push_long(context, context->regs_a[opword & 7]);
    context->regs_a[opword & 7] = context->regs_a[7];
    context->regs_a[7] += tmp; /* FIXME: make sure this sign-extends */
}

void m68k_do_UNLK(struct emu68k_context *context, unsigned short opword)
{
/*     deb_printf("UNLK.\n"); */
    context->regs_a[7] = context->regs_a[opword & 7];
    context->regs_a[opword & 7] = m68k_pop_long(context);
}

void m68k_do_CMP_byte(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type & AMT_DATA) {
	src.api->resolve(&src, context, AMS_BYTE);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readbyte(&src);
	data3 = data2 - data;
	FLAG_NZ_byte(context, data3);
	FLAG_VC_SUB_byte(context, data3, data2, data);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CMP_word(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
/*     deb_printf("CMP_word.\n"); */

    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_WORD);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readword(&src);
	data3 = data2 - data;
	FLAG_NZ_word(context, data3);
	FLAG_VC_SUB_word(context, data3, data2, data);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_CMP_long(struct emu68k_context *context, unsigned short opword)
{
    struct m68k_amode src;
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    src = m68k_get_src_amode(opword);

    if (src.type) {
	src.api->resolve(&src, context, AMS_LONG);

	data = context->regs_d[(opword >> 9) & 7];
	data2 = src.api->readlong(&src);
	data3 = data2 - data;
	FLAG_NZ_long(context, data3);
	FLAG_VC_SUB_long(context, data3, data2, data);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_LSL_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (0x80 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_LSL_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    
    FLAG_NZ_word(context, data3);

    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_LSL_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    
    FLAG_NZ_long(context, data3);

    if (data2 & (0x80000000 >> (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_LSL_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	
	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 << data;
    
	FLAG_NZ_word(context, data3);

	if (data2 & (0x8000 >> (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_LSR_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_LSR_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_LSR_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_LSR_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);

	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 >> data;
    
	FLAG_NZ_word(context, data3);

	if (data2 & (1 << (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);

	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ASR_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;

    if (data2 & 0x80) {
	data3 |= (0xff << (8 - data));
    }
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ASR_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    if (data2 & 0x8000) {
	data3 |= (0xff00 << (8 - data));
    }
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ASR_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    if (data2 & 0x80000000) {
	data3 |= (0xff000000 << (8 - data));
    }
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ASR_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);

	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 >> data;
    
	FLAG_NZ_word(context, data3);

	if (data2 & (1 << (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);

	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ROL_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (8 - data);
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (0x80 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROL_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (16 - data);
    
    FLAG_NZ_word(context, data3);

    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROL_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (32 - data);
    
    FLAG_NZ_long(context, data3);

    if (data2 & (0x80000000 >> (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROL_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	
	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 << data;
	data3 |= data2 >> (16 - data);
    
	FLAG_NZ_word(context, data3);

	if (data2 & (0x8000 >> (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ROR_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (8 - data);
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROR_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (16 - data);
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROR_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (32 - data);
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROR_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	
	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 >> data;
	data3 |= data2 << (16 - data);
    
	FLAG_NZ_word(context, data3);

	if (data2 & (1 << (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ROXL_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (7 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (0x80 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXL_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (15 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_word(context, data3);

    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXL_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (31 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_long(context, data3);

    if (data2 & (0x80000000 >> (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROXL_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	
	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 << data;
	data3 |= data2 >> (15 - data);
	if (context->flags & 0x10) {
	    data3 |= 1 << (data - 1);
	}
    
	FLAG_NZ_word(context, data3);

	if (data2 & (0x8000 >> (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

void m68k_do_ROXR_r_byte(struct emu68k_context *context, unsigned short opword)
{
    unsigned char data;
    unsigned char data2;
    unsigned char data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (7 - data);
    if (context->flags & 0x10) {
	data3 |= 0x80 >> (data - 1);
    }
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((unsigned char)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXR_r_word(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (15 - data);
    if (context->flags & 0x10) {
	data3 |= 0x8000 >> (data - 1);
    }
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }

    ((unsigned short)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXR_r_long(struct emu68k_context *context, unsigned short opword)
{
    unsigned long data;
    unsigned long data2;
    unsigned long data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (31 - data);
    if (context->flags & 0x10) {
	data3 |= 0x80000000 >> (data - 1);
    }
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROXR_m(struct emu68k_context *context, unsigned short opword)
{
    unsigned short data;
    unsigned short data2;
    unsigned short data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if ((src.type & (AMT_MEMORY | AMT_ALTERABLE)) == (AMT_MEMORY | AMT_ALTERABLE)) {
	src.api->resolve(&src, context, AMS_WORD);
	
	data = 1;
	data2 = src.api->readword(&src);
	data3 = data2 >> data;
	data3 |= data2 << (15 - data);
	if (context->flags & 0x10) {
	    data3 |= 0x8000 >> (data - 1);
	}
    
	FLAG_NZ_word(context, data3);

	if (data2 & (1 << (data - 1))) {
	    context->flags |= 0x11;
	}

	src.api->writeword(&src, data3);
	
	src.api->after(&src);
    } else {
	deb_printf("invalid amode, opword 0x%04hx, address 0x%06x.\n", opword, context->pc - 2);
	/* FIXME: signal invalid amode */
    }
}

/*
 * $Log: emu68k.c,v $
 * Revision 1.2  1999/06/19 18:44:27  nyef
 * added preliminary implementation of amode 6 (register indirect index)
 *
 * Revision 1.1  1999/04/17 22:24:55  nyef
 * Initial revision
 *
 */
