/*
 * emu6502.h
 *
 * 6502 emulation defines
 */

/* $Id: emuz80.h,v 1.3 1999/04/17 20:07:38 nyef Exp $ */

#ifndef __EMUZ80_H__
#define __EMUZ80_H__

#include "cal.h"

#define BYTE unsigned char
#define WORD unsigned short

#define PACKED __attribute__ ((packed))

/* registers */

struct emuz80_context {
    BYTE reg_F;
    BYTE reg_A;
    BYTE reg_C;
    BYTE reg_B;
    BYTE reg_E;
    BYTE reg_D;
    BYTE reg_L;
    BYTE reg_H;
    BYTE reg_F_;
    BYTE reg_A_;
    BYTE reg_C_;
    BYTE reg_B_;
    BYTE reg_E_;
    BYTE reg_D_;
    BYTE reg_L_;
    BYTE reg_H_;
    BYTE reg_I;
    BYTE reg_R;
    WORD reg_IX;
    WORD reg_IY;
    WORD reg_SP;
    WORD reg_PC;
    memread8_t *readtable;
    memwrite8_t *writetable;
    long cycles_left;
    long mmu_shift;
    long mmu_mask;
    void *user;
    void *dispatch;
    void *decodemap;
    memread8_t io_read;
    memwrite8_t io_write;
} PACKED;


/* functions */

void emuz80_step(struct emuz80_context *context);
void emuz80_run(struct emuz80_context *context);

void emuz80_reset(struct emuz80_context *context);
void emuz80_NMI(struct emuz80_context *context);
void emuz80_IRQ(struct emuz80_context *context);

void emuz80_init(struct emuz80_context *context);

#endif /* __EMUZ80_H__ */

/*
 * $Log: emuz80.h,v $
 * Revision 1.3  1999/04/17 20:07:38  nyef
 * fixed for new version of the CAL.
 *
 * Revision 1.2  1999/01/02 06:35:21  nyef
 * added io interface.
 *
 * Revision 1.1  1999/01/01 20:43:57  nyef
 * Initial revision
 *
 */
