/*
 * flags.c
 *
 * flag translation tables
 */

/* $Id: flags.c,v 1.1 1998/07/11 22:17:27 nyef Exp $ */

#include "flags.h"

/* WARNING: these must be the same as in emudefs.h */
#define fc_8088 0x01
#define fb_8088 0x02
#define f1_8088 0x04
#define fv_8088 0x08
#define fd_8088 0x10
#define fi_8088 0x20
#define fz_8088 0x40
#define fn_8088 0x80


/* WARNING: these are the values in the _real_ 6502. do not change them. */
#define fc_6502 0x01 /* Carry flag */
#define fz_6502 0x02 /* Zero flag */
#define fi_6502 0x04 /* Interrupt disable flag */
#define fd_6502 0x08 /* Decimal mode flag */
#define fb_6502 0x10 /* Break command flag (Usually 0) */
#define f1_6502 0x20 /* Reserved (always 1) */
#define fv_6502 0x40 /* Overflow flag */
#define fn_6502 0x80 /* Negative flag */


unsigned char flags_to_8088[256];

unsigned char flags_to_6502[256];


void init_flag_tables(void)
{
    int i;
    unsigned char p;

    for (i = 0; i < 0x100; i++) {
        p = 0;

	if (i & fc_6502) p |= fc_8088;
	if (i & fz_6502) p |= fz_8088;
	if (i & fi_6502) p |= fi_8088;
	if (i & fd_6502) p |= fd_8088;
	if (i & fb_6502) p |= fb_8088;
	if (i & f1_6502) p |= f1_8088;
	if (i & fv_6502) p |= fv_8088;
	if (i & fn_6502) p |= fn_8088;

	flags_to_6502[p] = ((i | f1_6502) & ~fb_6502);
	flags_to_8088[i] = ((p | f1_8088) & ~fb_8088);
    }
}

/*
 * $Log: flags.c,v $
 * Revision 1.1  1998/07/11 22:17:27  nyef
 * Initial revision
 *
 */
