/*
 * gen_vdp.h
 *
 * genesis custom vdp emulation.
 */

#ifndef GEN_VDP_H
#define GEN_VDP_H

/* $Id: gen_vdp.h,v 1.1 1999/04/17 22:24:50 nyef Exp $ */

typedef struct gen_vdp *gen_vdp;

typedef unsigned short (*portread_t)(gen_vdp);
typedef void (*portwrite_t)(gen_vdp, unsigned short);
typedef int (*periodic_t)(gen_vdp);

struct gen_vdp {
    portread_t readport0; /* data port */
    portread_t readport1; /* control port */
    portwrite_t writeport0;
    portwrite_t writeport1;
/*     portread_t readscanline; */
    periodic_t periodic;

    unsigned short flags;
    unsigned short readahead;
    unsigned short addrsave;
    unsigned char status;
    unsigned char *memory;
    unsigned char regs[24];
    unsigned char palette[128];
    unsigned char palette_xlat[64];
    unsigned long address;
    unsigned short cur_scanline;
    unsigned char linecounter;
};

gen_vdp gen_vdp_create(void);

#endif /* GEN_VDP_H */

/*
 * $Log: gen_vdp.h,v $
 * Revision 1.1  1999/04/17 22:24:50  nyef
 * Initial revision
 *
 */
