/*
 * opc6280.S
 *
 * 6280 opcode emulation
 */

/* $Id: opc6280.S,v 1.22 1999/05/23 15:09:29 nyef Exp $ */

#include "opc6280.h"

/* opcode map */
	.globl opc6280_map
opc6280_map:
	.long op_BRK		/* 00 */
	.long op_ORA_indx	/* 01 */
	.long op_SXY		/* 02 */
	.long op_ST0		/* 03 */
	.long op_TSB_zpage	/* 04 */
	.long op_ORA_zpage	/* 05 */
	.long op_ASL_zpage	/* 06 */
	.long op_RMB0		/* 07 */
	.long op_PHP		/* 08 */
	.long op_ORA_imm	/* 09 */
	.long op_ASL_a		/* 0A */
	.long op_UNIMP		/* 0B */
	.long op_TSB_abs	/* 0C */
	.long op_ORA_abs	/* 0D */
	.long op_ASL_abs	/* 0E */
	.long op_BBR0		/* 0F */
	.long op_BPL		/* 10 */
	.long op_ORA_indy	/* 11 */
	.long op_ORA_ind	/* 12 */
	.long op_ST1		/* 13 */
	.long op_TRB_zpage	/* 14 */
	.long op_ORA_zpagex	/* 15 */
	.long op_ASL_zpagex	/* 16 */
	.long op_RMB1		/* 17 */
	.long op_CLC		/* 18 */
	.long op_ORA_absy	/* 19 */
	.long op_INC_a		/* 1A */
	.long op_UNIMP		/* 1B */
	.long op_TRB_abs	/* 1C */
	.long op_ORA_absx	/* 1D */
	.long op_ASL_absx	/* 1E */
	.long op_BBR1		/* 1F */
	.long op_JSR_abs	/* 20 */
	.long op_AND_indx	/* 21 */
	.long op_SAX		/* 22 */
	.long op_ST2		/* 23 */
	.long op_BIT_zpage	/* 24 */
	.long op_AND_zpage	/* 25 */
	.long op_ROL_zpage	/* 26 */
	.long op_RMB2		/* 27 */
	.long op_PLP		/* 28 */
	.long op_AND_imm	/* 29 */
	.long op_ROL_a		/* 2A */
	.long op_UNIMP		/* 2B */
	.long op_BIT_abs	/* 2C */
	.long op_AND_abs	/* 2D */
	.long op_ROL_abs	/* 2E */
	.long op_BBR2		/* 2F */
	.long op_BMI		/* 30 */
	.long op_AND_indy	/* 31 */
	.long op_AND_ind	/* 32 */
	.long op_UNIMP		/* 33 */
	.long op_BIT_zpagex	/* 34 */
	.long op_AND_zpagex	/* 35 */
	.long op_ROL_zpagex	/* 36 */
	.long op_RMB3		/* 37 */
	.long op_SEC		/* 38 */
	.long op_AND_absy	/* 39 */
	.long op_DEC_a		/* 3A */
	.long op_UNIMP		/* 3B */
	.long op_BIT_absx	/* 3C */
	.long op_AND_absx	/* 3D */
	.long op_ROL_absx	/* 3E */
	.long op_BBR3		/* 3F */
	.long op_RTI		/* 40 */
	.long op_EOR_indx	/* 41 */
	.long op_SAY		/* 42 */
	.long op_TMA		/* 43 */
	.long op_BSR		/* 44 */
	.long op_EOR_zpage	/* 45 */
	.long op_LSR_zpage	/* 46 */
	.long op_RMB4		/* 47 */
	.long op_PHA		/* 48 */
	.long op_EOR_imm	/* 49 */
	.long op_LSR_a		/* 4A */
	.long op_UNIMP		/* 4B */
	.long op_JMP_abs	/* 4C */
	.long op_EOR_abs	/* 4D */
	.long op_LSR_abs	/* 4E */
	.long op_BBR4		/* 4F */
	.long op_BVC		/* 50 */
	.long op_EOR_indy	/* 51 */
	.long op_EOR_ind	/* 52 */
	.long op_TAM		/* 53 */
	.long op_CSL		/* 54 */
	.long op_EOR_zpagex	/* 55 */
	.long op_LSR_zpagex	/* 56 */
	.long op_RMB5		/* 57 */
	.long op_CLI		/* 58 */
	.long op_EOR_absy	/* 59 */
	.long op_PHY		/* 5A */
	.long op_UNIMP		/* 5B */
	.long op_UNIMP		/* 5C */
	.long op_EOR_absx	/* 5D */
	.long op_LSR_absx	/* 5E */
	.long op_BBR5		/* 5F */
	.long op_RTS		/* 60 */
	.long op_ADC_indx	/* 61 */
	.long op_CLA		/* 62 */
	.long op_UNIMP		/* 63 */
	.long op_STZ_zpage	/* 64 */
	.long op_ADC_zpage	/* 65 */
	.long op_ROR_zpage	/* 66 */
	.long op_RMB6		/* 67 */
	.long op_PLA		/* 68 */
	.long op_ADC_imm	/* 69 */
	.long op_ROR_a		/* 6A */
	.long op_UNIMP		/* 6B */
	.long op_65c02_JMP_ind	/* 6C */
	.long op_ADC_abs	/* 6D */
	.long op_ROR_abs	/* 6E */
	.long op_BBR6		/* 6F */
	.long op_BVS		/* 70 */
	.long op_ADC_indy	/* 71 */
	.long op_ADC_ind	/* 72 */
	.long op_TII		/* 73 */
	.long op_STZ_zpagex	/* 74 */
	.long op_ADC_zpagex	/* 75 */
	.long op_ROR_zpagex	/* 76 */
	.long op_RMB7		/* 77 */
	.long op_SEI		/* 78 */
	.long op_ADC_absy	/* 79 */
	.long op_PLY		/* 7A */
	.long op_UNIMP		/* 7B */
	.long op_JMP_indx	/* 7C */
	.long op_ADC_absx	/* 7D */
	.long op_ROR_absx	/* 7E */
	.long op_BBR7		/* 7F */
	.long op_BRA		/* 80 */
	.long op_STA_indx	/* 81 */
	.long op_CLX		/* 82 */
	.long op_TST_zpage	/* 83 */
	.long op_STY_zpage	/* 84 */
	.long op_STA_zpage	/* 85 */
	.long op_STX_zpage	/* 86 */
	.long op_SMB0		/* 87 */
	.long op_DEY		/* 88 */
	.long op_BIT_imm	/* 89 */
	.long op_TXA		/* 8A */
	.long op_UNIMP		/* 8B */
	.long op_STY_abs	/* 8C */
	.long op_STA_abs	/* 8D */
	.long op_STX_abs	/* 8E */
	.long op_BBS0		/* 8F */
	.long op_BCC		/* 90 */
	.long op_STA_indy	/* 91 */
	.long op_STA_ind	/* 92 */
	.long op_TST_abs	/* 93 */
	.long op_STY_zpagex	/* 94 */
	.long op_STA_zpagex	/* 95 */
	.long op_STX_zpagey	/* 96 */
	.long op_SMB1		/* 97 */
	.long op_TYA		/* 98 */
	.long op_STA_absy	/* 99 */
	.long op_TXS		/* 9A */
	.long op_UNIMP		/* 9B */
	.long op_STZ_abs	/* 9C */
	.long op_STA_absx	/* 9D */
	.long op_STZ_absx	/* 9E */
	.long op_BBS1		/* 9F */
	.long op_LDY_imm	/* A0 */
	.long op_LDA_indx	/* A1 */
	.long op_LDX_imm	/* A2 */
	.long op_TST_zpagex	/* A3 */
	.long op_LDY_zpage	/* A4 */
	.long op_LDA_zpage	/* A5 */
	.long op_LDX_zpage	/* A6 */
	.long op_SMB2		/* A7 */
	.long op_TAY		/* A8 */
	.long op_LDA_imm	/* A9 */
	.long op_TAX		/* AA */
	.long op_UNIMP		/* AB */
	.long op_LDY_abs	/* AC */
	.long op_LDA_abs	/* AD */
	.long op_LDX_abs	/* AE */
	.long op_BBS2		/* AF */
	.long op_BCS		/* B0 */
	.long op_LDA_indy	/* B1 */
	.long op_LDA_ind	/* B2 */
	.long op_TST_absx	/* B3 */
	.long op_LDY_zpagex	/* B4 */
	.long op_LDA_zpagex	/* B5 */
	.long op_LDX_zpagey	/* B6 */
	.long op_SMB3		/* B7 */
	.long op_CLV		/* B8 */
	.long op_LDA_absy	/* B9 */
	.long op_TSX		/* BA */
	.long op_UNIMP		/* BB */
	.long op_LDY_absx	/* BC */
	.long op_LDA_absx	/* BD */
	.long op_LDX_absy	/* BE */
	.long op_BBS3		/* BF */
	.long op_CPY_imm	/* C0 */
	.long op_CMP_indx	/* C1 */
	.long op_CLY		/* C2 */
	.long op_TDD		/* C3 */
	.long op_CPY_zpage	/* C4 */
	.long op_CMP_zpage	/* C5 */
	.long op_DEC_zpage	/* C6 */
	.long op_SMB4		/* C7 */
	.long op_INY		/* C8 */
	.long op_CMP_imm	/* C9 */
	.long op_DEX		/* CA */
	.long op_UNIMP		/* CB */
	.long op_CPY_abs	/* CC */
	.long op_CMP_abs	/* CD */
	.long op_DEC_abs	/* CE */
	.long op_BBS4		/* CF */
	.long op_BNE		/* D0 */
	.long op_CMP_indy	/* D1 */
	.long op_CMP_ind	/* D2 */
	.long op_TIN		/* D3 */
	.long op_CSH		/* D4 */
	.long op_CMP_zpagex	/* D5 */
	.long op_DEC_zpagex	/* D6 */
	.long op_SMB5		/* D7 */
	.long op_CLD		/* D8 */
	.long op_CMP_absy	/* D9 */
	.long op_PHX		/* DA */
	.long op_UNIMP		/* DB */
	.long op_UNIMP		/* DC */
	.long op_CMP_absx	/* DD */
	.long op_DEC_absx	/* DE */
	.long op_BBS5		/* DF */
	.long op_CPX_imm	/* E0 */
	.long op_SBC_indx	/* E1 */
	.long op_UNIMP		/* E2 */
	.long op_TIA		/* E3 */
	.long op_CPX_zpage	/* E4 */
	.long op_SBC_zpage	/* E5 */
	.long op_INC_zpage	/* E6 */
	.long op_SMB6		/* E7 */
	.long op_INX		/* E8 */
	.long op_SBC_imm	/* E9 */
	.long op_NOP		/* EA */
	.long op_UNIMP		/* EB */
	.long op_CPX_abs	/* EC */
	.long op_SBC_abs	/* ED */
	.long op_INC_abs	/* EE */
	.long op_BBS6		/* EF */
	.long op_BEQ		/* F0 */
	.long op_SBC_indy	/* F1 */
	.long op_SBC_ind	/* F2 */
	.long op_TAI		/* F3 */
	.long op_UNIMP		/* F4 */
	.long op_SBC_zpagex	/* F5 */
	.long op_INC_zpagex	/* F6 */
	.long op_SMB7		/* F7 */
	.long op_SED		/* F8 */
	.long op_SBC_absy	/* F9 */
	.long op_PLX		/* FA */
	.long op_UNIMP		/* FB */
	.long op_UNIMP		/* FC */
	.long op_SBC_absx	/* FD */
	.long op_INC_absx	/* FE */
	.long op_BBS7		/* FF */


/* emulation register map */
/* %edi = effective address */
/* %esi = memaccess scratch */
/* %edx = PC */
/* %ch = P */
/* %ax = opcode scratch */

	.globl op_CSH
op_CSH:
	/* FIXME: find out what this is supposed to do */
	Continue

	.globl op_CSL
op_CSL:
	/* FIXME: find out what this is supposed to do */
	Continue

#define do_TAM(x) bt $x, %eax; jnc 0f; movb %cl, mpr##x; 0:

	.globl op_TAM
op_TAM:
	GetFromPC_B
	MemReadNorm
	movb reg_A, %cl
	do_TAM(0)
	do_TAM(1)
	do_TAM(2)
	do_TAM(3)
	do_TAM(4)
	do_TAM(5)
	do_TAM(6)
	do_TAM(7)
	Continue
	
#define do_TMA(x) bt $x, %eax; jnc 0f; orb mpr##x, %cl; 0:

	.globl op_TMA
op_TMA:
	GetFromPC_B
	MemReadNorm
	xorb %cl, %cl
	do_TMA(0)
	do_TMA(1)
	do_TMA(2)
	do_TMA(3)
	do_TMA(4)
	do_TMA(5)
	do_TMA(6)
	do_TMA(7)
	movb %cl, reg_A
	Continue

	.globl op_CLA
op_CLA:
	xorb %al, %al
	movb %al, reg_A
	Continue

	.globl op_CLX
op_CLX:
	xorb %al, %al
	movb %al, reg_X
	Continue

	.globl op_CLY
op_CLY:
	xorb %al, %al
	movb %al, reg_Y
	Continue

	.globl op_SMB0
op_SMB0:
	DoSMB($0)
	Continue

	.globl op_SMB1
op_SMB1:
	DoSMB($1)
	Continue

	.globl op_SMB2
op_SMB2:
	DoSMB($2)
	Continue

	.globl op_SMB3
op_SMB3:
	DoSMB($3)
	Continue

	.globl op_SMB4
op_SMB4:
	DoSMB($4)
	Continue

	.globl op_SMB5
op_SMB5:
	DoSMB($5)
	Continue

	.globl op_SMB6
op_SMB6:
	DoSMB($6)
	Continue

	.globl op_SMB7
op_SMB7:
	DoSMB($7)
	Continue

	.globl op_RMB0
op_RMB0:
	DoRMB($0)
	Continue

	.globl op_RMB1
op_RMB1:
	DoRMB($1)
	Continue

	.globl op_RMB2
op_RMB2:
	DoRMB($2)
	Continue

	.globl op_RMB3
op_RMB3:
	DoRMB($3)
	Continue

	.globl op_RMB4
op_RMB4:
	DoRMB($4)
	Continue

	.globl op_RMB5
op_RMB5:
	DoRMB($5)
	Continue

	.globl op_RMB6
op_RMB6:
	DoRMB($6)
	Continue

	.globl op_RMB7
op_RMB7:
	DoRMB($7)
	Continue

	.globl op_BBS0
op_BBS0:
	DoBBS($0)
	Continue

	.globl op_BBS1
op_BBS1:
	DoBBS($1)
	Continue

	.globl op_BBS2
op_BBS2:
	DoBBS($2)
	Continue

	.globl op_BBS3
op_BBS3:
	DoBBS($3)
	Continue

	.globl op_BBS4
op_BBS4:
	DoBBS($4)
	Continue

	.globl op_BBS5
op_BBS5:
	DoBBS($5)
	Continue

	.globl op_BBS6
op_BBS6:
	DoBBS($6)
	Continue

	.globl op_BBS7
op_BBS7:
	DoBBS($7)
	Continue

	.globl op_BBR0
op_BBR0:
	DoBBR($0)
	Continue

	.globl op_BBR1
op_BBR1:
	DoBBR($1)
	Continue

	.globl op_BBR2
op_BBR2:
	DoBBR($2)
	Continue

	.globl op_BBR3
op_BBR3:
	DoBBR($3)
	Continue

	.globl op_BBR4
op_BBR4:
	DoBBR($4)
	Continue

	.globl op_BBR5
op_BBR5:
	DoBBR($5)
	Continue

	.globl op_BBR6
op_BBR6:
	DoBBR($6)
	Continue

	.globl op_BBR7
op_BBR7:
	DoBBR($7)
	Continue

	.globl op_BSR
op_BSR:
	movl %edx, %edi
	MemReadNorm
	push(%dh)
	push(%dl)
	cbw
	addw %ax, %dx
	incw %dx
	Continue

	.globl op_TAI
op_TAI:
	movb reg_Y, %al
	push(%al)
	movb reg_A, %al
	push(%al)
	movb reg_X, %al
	push(%al)
	GetFromPC_W	/* Source */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Dest */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Count */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
9:	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	incw 0x8(%esp)	/* Source */
	incw 0x4(%esp)	/* Dest */
	decw (%esp)	/* Count */
	jz 9f
	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	decw 0x8(%esp)	/* Source */
	incw 0x4(%esp)	/* Dest */
	decw (%esp)	/* Count */
	jnz 9b
9:	addl $0xc, %esp
	/* FIXME: add cycle timing data */
	pop(%al)
	movb %al, reg_X
	pop(%al)
	movb %al, reg_A
	pop(%al)
	movb %al, reg_Y
	Continue

	.globl op_TIA
op_TIA:
	movb reg_Y, %al
	push(%al)
	movb reg_A, %al
	push(%al)
	movb reg_X, %al
	push(%al)
	GetFromPC_W	/* Source */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Dest */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Count */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
9:	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	incw 0x8(%esp)	/* Source */
	incw 0x4(%esp)	/* Dest */
	decw (%esp)	/* Count */
	jz 9f
	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	incw 0x8(%esp)	/* Source */
	decw 0x4(%esp)	/* Dest */
	decw (%esp)	/* Count */
	jnz 9b
9:	addl $0xc, %esp
	/* FIXME: add cycle timing data */
	pop(%al)
	movb %al, reg_X
	pop(%al)
	movb %al, reg_A
	pop(%al)
	movb %al, reg_Y
	Continue

	.globl op_TII
op_TII:
	movb reg_Y, %al
	push(%al)
	movb reg_A, %al
	push(%al)
	movb reg_X, %al
	push(%al)
	GetFromPC_W	/* Source */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Dest */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Count */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
9:	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	incw 0x8(%esp)	/* Source */
	incw 0x4(%esp)	/* Dest */
	decw (%esp)	/* Count */
	jnz 9b
	addl $0xc, %esp
	/* FIXME: add cycle timing data */
	pop(%al)
	movb %al, reg_X
	pop(%al)
	movb %al, reg_A
	pop(%al)
	movb %al, reg_Y
	Continue

	.globl op_TDD
op_TDD:
	movb reg_Y, %al
	push(%al)
	movb reg_A, %al
	push(%al)
	movb reg_X, %al
	push(%al)
	GetFromPC_W	/* Source */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Dest */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Count */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
9:	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	decw 0x8(%esp)	/* Source */
	decw 0x4(%esp)	/* Dest */
	decw (%esp)	/* Count */
	jnz 9b
	addl $0xc, %esp
	/* FIXME: add cycle timing data */
	pop(%al)
	movb %al, reg_X
	pop(%al)
	movb %al, reg_A
	pop(%al)
	movb %al, reg_Y
	Continue

	.globl op_TIN
op_TIN:
	movb reg_Y, %al
	push(%al)
	movb reg_A, %al
	push(%al)
	movb reg_X, %al
	push(%al)
	GetFromPC_W	/* Source */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Dest */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
	GetFromPC_W	/* Count */
	MemReadW(Norm)
	andl $0xffff, %eax
	pushl %eax
9:	movl 0x8(%esp), %edi
	MemReadNorm
	movl 0x4(%esp), %edi
	MemWriteNorm
	incw 0x8(%esp)	/* Source */
	decw (%esp)	/* Count */
	jnz 9b
	addl $0xc, %esp
	/* FIXME: add cycle timing data */
	pop(%al)
	movb %al, reg_X
	pop(%al)
	movb %al, reg_A
	pop(%al)
	movb %al, reg_Y
	Continue

	.globl op_ST0
op_ST0:
	GetFromPC_B
	MemReadNorm
	pushal
	pushl %eax
	call SYMNAME(pce_st0_hack)
	popl %eax
	popal
	Continue

	.globl op_ST1
op_ST1:
	GetFromPC_B
	MemReadNorm
	pushal
	pushl %eax
	call SYMNAME(pce_st1_hack)
	popl %eax
	popal
	Continue

	.globl op_ST2
op_ST2:
	GetFromPC_B
	MemReadNorm
	pushal
	pushl %eax
	call SYMNAME(pce_st2_hack)
	popl %eax
	popal
	Continue

	.globl op_SAX
op_SAX:
	movb reg_X, %al
	movb reg_A, %ah
	movb %ah, reg_X
	movb %al, reg_A
	Continue

	.globl op_SAY
op_SAY:
	movb reg_A, %al
	movb reg_Y, %ah
	movb %ah, reg_A
	movb %al, reg_Y
	Continue

	.globl op_SXY
op_SXY:
	movb reg_X, %al
	movb reg_Y, %ah
	movb %ah, reg_X
	movb %al, reg_Y
	Continue

	.globl op_TST_zpage
op_TST_zpage:
	GetFromPC_B
	MemReadNorm
	movb %al, %cl
	GetZPage
	DoTST(ZPage)
	Continue

	.globl op_TST_zpagex
op_TST_zpagex:
	GetFromPC_B
	MemReadNorm
	movb %al, %cl
	GetZPageX
	DoTST(ZPage)
	Continue

	.globl op_TST_abs
op_TST_abs:
	GetFromPC_B
	MemReadNorm
	movb %al, %cl
	GetAbs
	DoTST(Norm)
	Continue

	.globl op_TST_absx
op_TST_absx:
	GetFromPC_B
	MemReadNorm
	movb %al, %cl
	GetAbsX
	DoTST(Norm)
	Continue

/*
 * $Log: opc6280.S,v $
 * Revision 1.22  1999/05/23 15:09:29  nyef
 * added TDD instruction
 *
 * Revision 1.21  1999/03/15 01:59:44  nyef
 * added saving/restoring of X, Y, and A regs to the block transfer
 * instructions. I'm not sure that this helps, but the develo book
 * says that it happens, so I added it
 *
 * Revision 1.20  1999/03/03 02:48:06  nyef
 * changed WAI and STP instructions (inherited from emu65c02) to UNIMP
 *
 * Revision 1.19  1999/02/03 01:19:02  nyef
 * fixed op_BSR to correctly calculate destination address
 *
 * Revision 1.18  1999/01/29 02:09:55  nyef
 * added TIN instruction
 *
 * Revision 1.17  1999/01/28 02:48:19  nyef
 * added the SAX and SAY instructions
 *
 * Revision 1.16  1999/01/28 02:44:58  nyef
 * added the TST instructions
 *
 * Revision 1.15  1999/01/28 02:23:53  nyef
 * added TIA instruction
 *
 * Revision 1.14  1999/01/28 02:21:13  nyef
 * added SXY instruction
 *
 * Revision 1.13  1999/01/28 02:17:48  nyef
 * added ST0, ST1, and ST2 instructions
 *
 * Revision 1.12  1999/01/17 22:41:59  nyef
 * added preliminary implimentation of BSR instruction.
 *
 * Revision 1.11  1999/01/17 02:09:15  nyef
 * added BBRi and BBSi instructions.
 *
 * Revision 1.10  1998/11/01 23:29:37  nyef
 * fixed all ZPage addressing modes to use direct ZPage access.
 *
 * Revision 1.9  1998/10/12 20:31:27  root
 * fixed TMA instruction to store the result into reg_A.
 *
 * Revision 1.8  1998/10/03 14:45:34  nyef
 * added TMA and TII instructions
 *
 * Revision 1.7  1998/07/27 00:00:14  nyef
 * added instructions CLA, CLX and CLY
 *
 * Revision 1.6  1998/07/26 22:43:08  nyef
 * fixed TAI opcode (changed 'xor' to 'and' in three places and added
 *    some 'MemReadW's)
 *
 * Revision 1.5  1998/07/16 01:32:38  nyef
 * added preliminary implimentation of the TAI instruction
 *
 * Revision 1.4  1998/07/15 01:44:16  nyef
 * added RMBi and SMBi instructions
 *
 * Revision 1.3  1998/07/15 01:07:53  nyef
 * added TAM opcode (still needs timing data)
 *
 * Revision 1.2  1998/07/15 00:58:49  nyef
 * added preliminary CSH and CSL opcodes as no-ops
 *
 * Revision 1.1  1998/07/14 02:07:48  nyef
 * Initial revision
 *
 */
