/*
 * opc6280.h
 *
 * 6280 opcode emulation macros
 */

/* $Id: opc6280.h,v 1.8 1999/02/01 02:31:45 nyef Exp $ */

#ifndef __OPC6280_H__
#define __OPC6280_H__

#ifndef __OPC65C02_H__
#include "opc65c02.h"
#endif

#define mpr0        0x31(%ebp)
#define mpr1        0x32(%ebp)
#define mpr2        0x33(%ebp)
#define mpr3        0x34(%ebp)
#define mpr4        0x35(%ebp)
#define mpr5        0x36(%ebp)
#define mpr6        0x37(%ebp)
#define mpr7        0x38(%ebp)

#define DoRMB(bit) GetFromPC_B; MemReadNorm; movzbl %al, %eax; movl page_0, %edi; btr bit, (%edi, %eax, 1); CYC_OP = 6
#define DoSMB(bit) GetFromPC_B; MemReadNorm; movzbl %al, %eax; movl page_0, %edi; bts bit, (%edi, %eax, 1); CYC_OP = 6

#define DoBBS(bit) GetZPage; MemReadZPage; GetFromPC_B; bt bit, %eax; jnc 0f; MemReadNorm; cbw; addw %ax, %dx; decl cycles_left; 0: CYC_OP = 3
#define DoBBR(bit) GetZPage; MemReadZPage; GetFromPC_B; bt bit, %eax; jc 0f; MemReadNorm; cbw; addw %ax, %dx; decl cycles_left; 0: CYC_OP = 3

#define DoTST(x) MemRead##x; movb %al, %ah; andb %cl, %ah; FlagZ; andl $0xc0, %eax; movb SYMNAME(flags_to_8088)(%eax), %al; andb flag_NV_not, %ch; orb %al, %ch

#endif /* __OPC6280_H__ */

/*
 * $Log: opc6280.h,v $
 * Revision 1.8  1999/02/01 02:31:45  nyef
 * fixed DoBBR and DoBBS macros
 *
 * Revision 1.7  1999/01/28 02:48:33  nyef
 * added macro definition for DoTST
 *
 * Revision 1.6  1999/01/17 02:09:36  nyef
 * added macro definitions for DoBBR and DoBBS
 *
 * Revision 1.5  1999/01/13 03:53:24  nyef
 * updated to comply with the new memory access spec.
 *
 * Revision 1.4  1998/11/01 23:29:45  nyef
 * fixed all ZPage addressing modes to use direct ZPage access.
 *
 * Revision 1.3  1998/07/15 01:42:47  nyef
 * fixed stupid naming mistake with DoRMB and DoSMB
 *
 * Revision 1.2  1998/07/15 01:10:24  nyef
 * added macro edefinitions for SMB and RMB
 *
 * Revision 1.1  1998/07/11 22:18:39  nyef
 * Initial revision
 *
 */
