/*
 * opc6502.S
 *
 * 6502 opcode emulation
 */

/* $Id: opc6502.S,v 1.3 1998/12/19 21:04:41 nyef Exp $ */

#include "opc6502.h"

/* opcode map */
	.globl SYMNAME(opc6502_map)
SYMLABEL(opc6502_map)
	.long op_BRK		/* 00 */
	.long op_ORA_indx	/* 01 */
	.long op_UNIMP		/* 02 */
	.long op_UNIMP		/* 03 */
	.long op_UNIMP		/* 04 */
	.long op_ORA_zpage	/* 05 */
	.long op_ASL_zpage	/* 06 */
	.long op_UNIMP		/* 07 */
	.long op_PHP		/* 08 */
	.long op_ORA_imm	/* 09 */
	.long op_ASL_a		/* 0A */
	.long op_UNIMP		/* 0B */
	.long op_UNIMP		/* 0C */
	.long op_ORA_abs	/* 0D */
	.long op_ASL_abs	/* 0E */
	.long op_UNIMP		/* 0F */
	.long op_BPL		/* 10 */
	.long op_ORA_indy	/* 11 */
	.long op_UNIMP		/* 12 */
	.long op_UNIMP		/* 13 */
	.long op_UNIMP		/* 14 */
	.long op_ORA_zpagex	/* 15 */
	.long op_ASL_zpagex	/* 16 */
	.long op_UNIMP		/* 17 */
	.long op_CLC		/* 18 */
	.long op_ORA_absy	/* 19 */
	.long op_UNIMP		/* 1A */
	.long op_UNIMP		/* 1B */
	.long op_UNIMP		/* 1C */
	.long op_ORA_absx	/* 1D */
	.long op_ASL_absx	/* 1E */
	.long op_UNIMP		/* 1F */
	.long op_JSR_abs	/* 20 */
	.long op_AND_indx	/* 21 */
	.long op_UNIMP		/* 22 */
	.long op_UNIMP		/* 23 */
	.long op_BIT_zpage	/* 24 */
	.long op_AND_zpage	/* 25 */
	.long op_ROL_zpage	/* 26 */
	.long op_UNIMP		/* 27 */
	.long op_PLP		/* 28 */
	.long op_AND_imm	/* 29 */
	.long op_ROL_a		/* 2A */
	.long op_UNIMP		/* 2B */
	.long op_BIT_abs	/* 2C */
	.long op_AND_abs	/* 2D */
	.long op_ROL_abs	/* 2E */
	.long op_UNIMP		/* 2F */
	.long op_BMI		/* 30 */
	.long op_AND_indy	/* 31 */
	.long op_UNIMP		/* 32 */
	.long op_UNIMP		/* 33 */
	.long op_UNIMP		/* 34 */
	.long op_AND_zpagex	/* 35 */
	.long op_ROL_zpagex	/* 36 */
	.long op_UNIMP		/* 37 */
	.long op_SEC		/* 38 */
	.long op_AND_absy	/* 39 */
	.long op_UNIMP		/* 3A */
	.long op_UNIMP		/* 3B */
	.long op_UNIMP		/* 3C */
	.long op_AND_absx	/* 3D */
	.long op_ROL_absx	/* 3E */
	.long op_UNIMP		/* 3F */
	.long op_RTI		/* 40 */
	.long op_EOR_indx	/* 41 */
	.long op_UNIMP		/* 42 */
	.long op_UNIMP		/* 43 */
	.long op_UNIMP		/* 44 */
	.long op_EOR_zpage	/* 45 */
	.long op_LSR_zpage	/* 46 */
	.long op_UNIMP		/* 47 */
	.long op_PHA		/* 48 */
	.long op_EOR_imm	/* 49 */
	.long op_LSR_a		/* 4A */
	.long op_UNIMP		/* 4B */
	.long op_JMP_abs	/* 4C */
	.long op_EOR_abs	/* 4D */
	.long op_LSR_abs	/* 4E */
	.long op_UNIMP		/* 4F */
	.long op_BVC		/* 50 */
	.long op_EOR_indy	/* 51 */
	.long op_UNIMP		/* 52 */
	.long op_UNIMP		/* 53 */
	.long op_UNIMP		/* 54 */
	.long op_EOR_zpagex	/* 55 */
	.long op_LSR_zpagex	/* 56 */
	.long op_UNIMP		/* 57 */
	.long op_CLI		/* 58 */
	.long op_EOR_absy	/* 59 */
	.long op_UNIMP		/* 5A */
	.long op_UNIMP		/* 5B */
	.long op_UNIMP		/* 5C */
	.long op_EOR_absx	/* 5D */
	.long op_LSR_absx	/* 5E */
	.long op_UNIMP		/* 5F */
	.long op_RTS		/* 60 */
	.long op_ADC_indx	/* 61 */
	.long op_UNIMP		/* 62 */
	.long op_UNIMP		/* 63 */
	.long op_UNIMP		/* 64 */
	.long op_ADC_zpage	/* 65 */
	.long op_ROR_zpage	/* 66 */
	.long op_UNIMP		/* 67 */
	.long op_PLA		/* 68 */
	.long op_ADC_imm	/* 69 */
	.long op_ROR_a		/* 6A */
	.long op_UNIMP		/* 6B */
	.long op_JMP_ind	/* 6C */
	.long op_ADC_abs	/* 6D */
	.long op_ROR_abs	/* 6E */
	.long op_UNIMP		/* 6F */
	.long op_BVS		/* 70 */
	.long op_ADC_indy	/* 71 */
	.long op_UNIMP		/* 72 */
	.long op_UNIMP		/* 73 */
	.long op_UNIMP		/* 74 */
	.long op_ADC_zpagex	/* 75 */
	.long op_ROR_zpagex	/* 76 */
	.long op_UNIMP		/* 77 */
	.long op_SEI		/* 78 */
	.long op_ADC_absy	/* 79 */
	.long op_UNIMP		/* 7A */
	.long op_UNIMP		/* 7B */
	.long op_UNIMP		/* 7C */
	.long op_ADC_absx	/* 7D */
	.long op_ROR_absx	/* 7E */
	.long op_UNIMP		/* 7F */
	.long op_UNIMP		/* 80 */
	.long op_STA_indx	/* 81 */
	.long op_UNIMP		/* 82 */
	.long op_UNIMP		/* 83 */
	.long op_STY_zpage	/* 84 */
	.long op_STA_zpage	/* 85 */
	.long op_STX_zpage	/* 86 */
	.long op_UNIMP		/* 87 */
	.long op_DEY		/* 88 */
	.long op_UNIMP		/* 89 */
	.long op_TXA		/* 8A */
	.long op_UNIMP		/* 8B */
	.long op_STY_abs	/* 8C */
	.long op_STA_abs	/* 8D */
	.long op_STX_abs	/* 8E */
	.long op_UNIMP		/* 8F */
	.long op_BCC		/* 90 */
	.long op_STA_indy	/* 91 */
	.long op_UNIMP		/* 92 */
	.long op_UNIMP		/* 93 */
	.long op_STY_zpagex	/* 94 */
	.long op_STA_zpagex	/* 95 */
	.long op_STX_zpagey	/* 96 */
	.long op_UNIMP		/* 97 */
	.long op_TYA		/* 98 */
	.long op_STA_absy	/* 99 */
	.long op_TXS		/* 9A */
	.long op_UNIMP		/* 9B */
	.long op_UNIMP		/* 9C */
	.long op_STA_absx	/* 9D */
	.long op_UNIMP		/* 9E */
	.long op_UNIMP		/* 9F */
	.long op_LDY_imm	/* A0 */
	.long op_LDA_indx	/* A1 */
	.long op_LDX_imm	/* A2 */
	.long op_UNIMP		/* A3 */
	.long op_LDY_zpage	/* A4 */
	.long op_LDA_zpage	/* A5 */
	.long op_LDX_zpage	/* A6 */
	.long op_UNIMP		/* A7 */
	.long op_TAY		/* A8 */
	.long op_LDA_imm	/* A9 */
	.long op_TAX		/* AA */
	.long op_UNIMP		/* AB */
	.long op_LDY_abs	/* AC */
	.long op_LDA_abs	/* AD */
	.long op_LDX_abs	/* AE */
	.long op_UNIMP		/* AF */
	.long op_BCS		/* B0 */
	.long op_LDA_indy	/* B1 */
	.long op_UNIMP		/* B2 */
	.long op_UNIMP		/* B3 */
	.long op_LDY_zpagex	/* B4 */
	.long op_LDA_zpagex	/* B5 */
	.long op_LDX_zpagey	/* B6 */
	.long op_UNIMP		/* B7 */
	.long op_CLV		/* B8 */
	.long op_LDA_absy	/* B9 */
	.long op_TSX		/* BA */
	.long op_UNIMP		/* BB */
	.long op_LDY_absx	/* BC */
	.long op_LDA_absx	/* BD */
	.long op_LDX_absy	/* BE */
	.long op_UNIMP		/* BF */
	.long op_CPY_imm	/* C0 */
	.long op_CMP_indx	/* C1 */
	.long op_UNIMP		/* C2 */
	.long op_UNIMP		/* C3 */
	.long op_CPY_zpage	/* C4 */
	.long op_CMP_zpage	/* C5 */
	.long op_DEC_zpage	/* C6 */
	.long op_UNIMP		/* C7 */
	.long op_INY		/* C8 */
	.long op_CMP_imm	/* C9 */
	.long op_DEX		/* CA */
	.long op_UNIMP		/* CB */
	.long op_CPY_abs	/* CC */
	.long op_CMP_abs	/* CD */
	.long op_DEC_abs	/* CE */
	.long op_UNIMP		/* CF */
	.long op_BNE		/* D0 */
	.long op_CMP_indy	/* D1 */
	.long op_UNIMP		/* D2 */
	.long op_UNIMP		/* D3 */
	.long op_UNIMP		/* D4 */
	.long op_CMP_zpagex	/* D5 */
	.long op_DEC_zpagex	/* D6 */
	.long op_UNIMP		/* D7 */
	.long op_CLD		/* D8 */
	.long op_CMP_absy	/* D9 */
	.long op_UNIMP		/* DA */
	.long op_UNIMP		/* DB */
	.long op_UNIMP		/* DC */
	.long op_CMP_absx	/* DD */
	.long op_DEC_absx	/* DE */
	.long op_UNIMP		/* DF */
	.long op_CPX_imm	/* E0 */
	.long op_SBC_indx	/* E1 */
	.long op_UNIMP		/* E2 */
	.long op_UNIMP		/* E3 */
	.long op_CPX_zpage	/* E4 */
	.long op_SBC_zpage	/* E5 */
	.long op_INC_zpage	/* E6 */
	.long op_UNIMP		/* E7 */
	.long op_INX		/* E8 */
	.long op_SBC_imm	/* E9 */
	.long op_NOP		/* EA */
	.long op_UNIMP		/* EB */
	.long op_CPX_abs	/* EC */
	.long op_SBC_abs	/* ED */
	.long op_INC_abs	/* EE */
	.long op_UNIMP		/* EF */
	.long op_BEQ		/* F0 */
	.long op_SBC_indy	/* F1 */
	.long op_UNIMP		/* F2 */
	.long op_UNIMP		/* F3 */
	.long op_UNIMP		/* F4 */
	.long op_SBC_zpagex	/* F5 */
	.long op_INC_zpagex	/* F6 */
	.long op_UNIMP		/* F7 */
	.long op_SED		/* F8 */
	.long op_SBC_absy	/* F9 */
	.long op_UNIMP		/* FA */
	.long op_UNIMP		/* FB */
	.long op_UNIMP		/* FC */
	.long op_SBC_absx	/* FD */
	.long op_INC_absx	/* FE */
	.long op_UNIMP		/* FF */


/* emulation register map */
/* %edi = effective address */
/* %esi = memaccess scratch */
/* %edx = PC */
/* %cl = A */
/* %ch = P */
/* %bl = X */
/* %bh = Y */
/* %ax = opcode scratch */


	.globl op_BPL
op_BPL:
	BxC(flag_N_bit)
	Continue
	
	.globl op_BMI
op_BMI:
	BxS(flag_N_bit)
	Continue

	.globl op_BVC
op_BVC:
	BxC(flag_V_bit)
	Continue
		
	.globl op_BVS
op_BVS:
	BxS(flag_V_bit)
	Continue
	
	.globl op_BCC
op_BCC:
	BxC(flag_C_bit)
	Continue
	
	.globl op_BCS
op_BCS:
	BxS(flag_C_bit)
	Continue
	
	.globl op_BNE
op_BNE:
	BxC(flag_Z_bit)
	Continue
	
	.globl op_BEQ
op_BEQ:
	BxS(flag_Z_bit)
	Continue
	
	.globl op_SEI
op_SEI:
	orb flag_I, %ch
	Continue

	.globl op_SED
op_SED:
	orb flag_D, %ch
	Continue

	.globl op_SEC
op_SEC:
	orb flag_C, %ch
	Continue

	.globl op_CLI
op_CLI:
	andb flag_I_not, %ch
	Continue

	.globl op_CLD
op_CLD:
	andb flag_D_not, %ch
	Continue

	.globl op_CLC
op_CLC:
	andb flag_C_not, %ch
	Continue

	.globl op_CLV
op_CLV:
	andb flag_V_not, %ch
	Continue

	.globl op_INC_zpage
op_INC_zpage:
	GetZPage
	DoINC(ZPage)
	Continue
	
	.globl op_INC_zpagex
op_INC_zpagex:
	GetZPageX
	DoINC(ZPage)
	Continue
	
	.globl op_INC_abs
op_INC_abs:
	GetAbs
	DoINC(Norm)
	Continue
	
	.globl op_INC_absx
op_INC_absx:
	GetAbsX
	DoINC(Norm)
	Continue
	
	.globl op_DEC_zpage
op_DEC_zpage:
	GetZPage
	DoDEC(ZPage)
	Continue
	
	.globl op_DEC_zpagex
op_DEC_zpagex:
	GetZPageX
	DoDEC(ZPage)
	Continue
	
	.globl op_DEC_abs
op_DEC_abs:
	GetAbs
	DoDEC(Norm)
	Continue
	
	.globl op_DEC_absx
op_DEC_absx:
	GetAbsX
	DoDEC(Norm)
	Continue
	
	.globl op_BIT_abs
op_BIT_abs:
	GetAbs
	DoBIT(Norm)
	Continue

	.globl op_BIT_zpage
op_BIT_zpage:
	GetZPage
	DoBIT(ZPage)
	Continue
	
	.globl op_LDA_imm
op_LDA_imm:
	GetImm
	DoLDA(Norm)
	Continue

	.globl op_LDA_abs
op_LDA_abs:
	GetAbs
	DoLDA(Norm)
	Continue

	.globl op_LDA_absx
op_LDA_absx:
	GetAbsX
	DoLDA(Norm)
	Continue

	.globl op_LDA_absy
op_LDA_absy:
	GetAbsY
	DoLDA(Norm)
	Continue

	.globl op_LDA_zpage
op_LDA_zpage:
	GetZPage
	DoLDA(ZPage)
	Continue

	.globl op_LDA_zpagex
op_LDA_zpagex:
	GetZPageX
	DoLDA(ZPage)
	Continue

	.globl op_LDA_indx
op_LDA_indx:
	GetIndX
	DoLDA(Norm)
	Continue

	.globl op_LDA_indy
op_LDA_indy:
	GetIndY
	DoLDA(Norm)
	Continue

	.globl op_LDX_imm
op_LDX_imm:
	GetImm
	DoLDX(Norm)
	Continue

	.globl op_LDX_abs
op_LDX_abs:
	GetAbs
	DoLDX(Norm)
	Continue

	.globl op_LDX_absy
op_LDX_absy:
	GetAbsY
	DoLDX(Norm)
	Continue

	.globl op_LDX_zpage
op_LDX_zpage:
	GetZPage
	DoLDX(ZPage)
	Continue

	.globl op_LDX_zpagey
op_LDX_zpagey:
	GetZPageY
	DoLDX(ZPage)
	Continue

	.globl op_LDY_imm
op_LDY_imm:
	GetImm
	DoLDY(Norm)
	Continue

	.globl op_LDY_abs
op_LDY_abs:
	GetAbs
	DoLDY(Norm)
	Continue

	.globl op_LDY_absx
op_LDY_absx:
	GetAbsX
	DoLDY(Norm)
	Continue

	.globl op_LDY_zpage
op_LDY_zpage:
	GetZPage
	DoLDY(ZPage)
	Continue

	.globl op_LDY_zpagex
op_LDY_zpagex:
	GetZPageX
	DoLDY(ZPage)
	Continue

	.globl op_STA_abs
op_STA_abs:
	GetAbs
	DoSTA(Norm)
	Continue

	.globl op_STA_absx
op_STA_absx:
	GetAbsX
	DoSTA(Norm)
	Continue

	.globl op_STA_absy
op_STA_absy:
	GetAbsY
	DoSTA(Norm)
	Continue

	.globl op_STA_zpage
op_STA_zpage:
	GetZPage
	DoSTA(ZPage)
	Continue

	.globl op_STA_zpagex
op_STA_zpagex:
	GetZPageX
	DoSTA(ZPage)
	Continue

	.globl op_STA_indx
op_STA_indx:
	GetIndX
	DoSTA(Norm)
	Continue

	.globl op_STA_indy
op_STA_indy:
	GetIndY
	DoSTA(Norm)
	Continue

	.globl op_STX_abs
op_STX_abs:
	GetAbs
	DoSTX(Norm)
	Continue

	.globl op_STX_zpage
op_STX_zpage:
	GetZPage
	DoSTX(ZPage)
	Continue

	.globl op_STX_zpagey
op_STX_zpagey:
	GetZPageY
	DoSTX(ZPage)
	Continue

	.globl op_STY_abs
op_STY_abs:
	GetAbs
	DoSTY(Norm)
	Continue

	.globl op_STY_zpage
op_STY_zpage:
	GetZPage
	DoSTY(ZPage)
	Continue

	.globl op_STY_zpagex
op_STY_zpagex:
	GetZPageX
	DoSTY(ZPage)
	Continue

	.globl op_DEX
op_DEX:
	DoDEX
	Continue
	
	.globl op_DEY
op_DEY:
	DoDEY
	Continue
	
	.globl op_INX
op_INX:
	DoINX
	Continue
	
	.globl op_INY
op_INY:
	DoINY
	Continue
	
	.globl op_TSX
op_TSX:
	DoTSX
	Continue
	
	.globl op_TXS
op_TXS:
	DoTXS
	Continue
	
	.globl op_TAX
op_TAX:
	DoTAX
	Continue
	
	.globl op_TAY
op_TAY:
	DoTAY
	Continue
	
	.globl op_TXA
op_TXA:
	DoTXA
	Continue
	
	.globl op_TYA
op_TYA:
	DoTYA
	Continue

	.globl op_EOR_imm
op_EOR_imm:	
	GetImm
	DoEOR(Norm)
	Continue
		
	.globl op_EOR_zpage
op_EOR_zpage:
	GetZPage
	DoEOR(ZPage)
	Continue
		
	.globl op_EOR_zpagex
op_EOR_zpagex:
	GetZPageX
	DoEOR(ZPage)
	Continue
		
	.globl op_EOR_abs
op_EOR_abs:
	GetAbs
	DoEOR(Norm)
	Continue
		
	.globl op_EOR_absx
op_EOR_absx:
	GetAbsX
	DoEOR(Norm)
	Continue
		
	.globl op_EOR_absy
op_EOR_absy:
	GetAbsY
	DoEOR(Norm)
	Continue
		
	.globl op_EOR_indx
op_EOR_indx:
	GetIndX
	DoEOR(Norm)
	Continue
		
	.globl op_EOR_indy
op_EOR_indy:
	GetIndY
	DoEOR(Norm)
	Continue
		
	.globl op_CMP_imm
op_CMP_imm:
	GetImm
	DoCMP(Norm)
	Continue

	.globl op_CMP_abs
op_CMP_abs:
	GetAbs
	DoCMP(Norm)
	Continue

	.globl op_CMP_absx
op_CMP_absx:
	GetAbsX
	DoCMP(Norm)
	Continue

	.globl op_CMP_absy
op_CMP_absy:
	GetAbsY
	DoCMP(Norm)
	Continue

	.globl op_CMP_zpage
op_CMP_zpage:
	GetZPage
	DoCMP(ZPage)
	Continue

	.globl op_CMP_zpagex
op_CMP_zpagex:
	GetZPageX
	DoCMP(ZPage)
	Continue

	.globl op_CMP_indx
op_CMP_indx:
	GetIndX
	DoCMP(Norm)
	Continue

	.globl op_CMP_indy
op_CMP_indy:
	GetIndY
	DoCMP(Norm)
	Continue

	.globl op_CPX_imm
op_CPX_imm:
	GetImm
	DoCPX(Norm)
	Continue
	
	.globl op_CPX_zpage
op_CPX_zpage:
	GetZPage
	DoCPX(ZPage)
	Continue
	
	.globl op_CPX_abs
op_CPX_abs:
	GetAbs
	DoCPX(Norm)
	Continue
	
	.globl op_CPY_imm
op_CPY_imm:
	GetImm
	DoCPY(Norm)
	Continue
	
	.globl op_CPY_zpage
op_CPY_zpage:
	GetZPage
	DoCPY(ZPage)
	Continue
	
	.globl op_CPY_abs
op_CPY_abs:
	GetAbs
	DoCPY(Norm)
	Continue

	.globl op_ADC_imm
op_ADC_imm:
	GetImm
	DoADC(Norm)
	Continue

	.globl op_ADC_abs
op_ADC_abs:
	GetAbs
	DoADC(Norm)
	Continue

	.globl op_ADC_absx
op_ADC_absx:
	GetAbsX
	DoADC(Norm)
	Continue

	.globl op_ADC_absy
op_ADC_absy:
	GetAbsY
	DoADC(Norm)
	Continue

	.globl op_ADC_indx
op_ADC_indx:
	GetIndX
	DoADC(Norm)
	Continue

	.globl op_ADC_indy
op_ADC_indy:
	GetIndY
	DoADC(Norm)
	Continue

	.globl op_ADC_zpage
op_ADC_zpage:
	GetZPage
	DoADC(ZPage)
	Continue

	.globl op_ADC_zpagex
op_ADC_zpagex:
	GetZPageX
	DoADC(ZPage)
	Continue

	.globl op_SBC_imm
op_SBC_imm:
	GetImm
	DoSBC(Norm)
	Continue

	.globl op_SBC_abs
op_SBC_abs:
	GetAbs
	DoSBC(Norm)
	Continue

	.globl op_SBC_absx
op_SBC_absx:
	GetAbsX
	DoSBC(Norm)
	Continue

	.globl op_SBC_absy
op_SBC_absy:
	GetAbsY
	DoSBC(Norm)
	Continue

	.globl op_SBC_indx
op_SBC_indx:
	GetIndX
	DoSBC(Norm)
	Continue

	.globl op_SBC_indy
op_SBC_indy:
	GetIndY
	DoSBC(Norm)
	Continue

	.globl op_SBC_zpage
op_SBC_zpage:
	GetZPage
	DoSBC(ZPage)
	Continue

	.globl op_SBC_zpagex
op_SBC_zpagex:
	GetZPageX
	DoSBC(ZPage)
	Continue

	.globl op_AND_imm
op_AND_imm:
	GetImm
	DoAND(Norm)
	Continue

	.globl op_AND_abs
op_AND_abs:
	GetAbs
	DoAND(Norm)
	Continue

	.globl op_AND_absx
op_AND_absx:
	GetAbsX
	DoAND(Norm)
	Continue

	.globl op_AND_absy
op_AND_absy:
	GetAbsY
	DoAND(Norm)
	Continue

	.globl op_AND_zpage
op_AND_zpage:
	GetZPage
	DoAND(ZPage)
	Continue

	.globl op_AND_zpagex
op_AND_zpagex:
	GetZPageX
	DoAND(ZPage)
	Continue

	.globl op_AND_indx
op_AND_indx:
	GetIndX
	DoAND(Norm)
	Continue

	.globl op_AND_indy
op_AND_indy:
	GetIndY
	DoAND(Norm)
	Continue

	.globl op_ORA_imm
op_ORA_imm:
	GetImm
	DoORA(Norm)
	Continue

	.globl op_ORA_abs
op_ORA_abs:
	GetAbs
	DoORA(Norm)
	Continue

	.globl op_ORA_absx
op_ORA_absx:
	GetAbsX
	DoORA(Norm)
	Continue

	.globl op_ORA_absy
op_ORA_absy:
	GetAbsY
	DoORA(Norm)
	Continue

	.globl op_ORA_zpage
op_ORA_zpage:
	GetZPage
	DoORA(ZPage)
	Continue

	.globl op_ORA_zpagex
op_ORA_zpagex:
	GetZPageX
	DoORA(ZPage)
	Continue

	.globl op_ORA_indx
op_ORA_indx:
	GetIndX
	DoORA(Norm)
	Continue
	
	.globl op_ORA_indy
op_ORA_indy:
	GetIndY
	DoORA(Norm)
	Continue
	
	.globl op_ASL_a
op_ASL_a:
	DoASLa
	Continue

	.globl op_ASL_zpage
op_ASL_zpage:
	GetZPage
	DoASL(ZPage)
	Continue

	.globl op_ASL_zpagex
op_ASL_zpagex:
	GetZPageX
	DoASL(ZPage)
	Continue

	.globl op_ASL_abs
op_ASL_abs:
	GetAbs
	DoASL(Norm)
	Continue

	.globl op_ASL_absx
op_ASL_absx:	
	GetAbsX
	DoASL(Norm)
	Continue

	.globl op_LSR_a
op_LSR_a:
	DoLSRa
	Continue

	.globl op_LSR_zpage
op_LSR_zpage:
	GetZPage
	DoLSR(ZPage)
	Continue

	.globl op_LSR_zpagex
op_LSR_zpagex:
	GetZPageX
	DoLSR(ZPage)
	Continue

	.globl op_LSR_abs
op_LSR_abs:
	GetAbs
	DoLSR(Norm)
	Continue

	.globl op_LSR_absx
op_LSR_absx:	
	GetAbsX
	DoLSR(Norm)
	Continue

	.globl op_ROL_a
op_ROL_a:
	DoROLa
	Continue

	.globl op_ROL_zpage
op_ROL_zpage:
	GetZPage
	DoROL(ZPage)
	Continue

	.globl op_ROL_zpagex
op_ROL_zpagex:
	GetZPageX
	DoROL(ZPage)
	Continue

	.globl op_ROL_abs
op_ROL_abs:
	GetAbs
	DoROL(Norm)
	Continue

	.globl op_ROL_absx
op_ROL_absx:	
	GetAbsX
	DoROL(Norm)
	Continue

	.globl op_ROR_a
op_ROR_a:
	DoRORa
	Continue

	.globl op_ROR_zpage
op_ROR_zpage:
	GetZPage
	DoROR(ZPage)
	Continue

	.globl op_ROR_zpagex
op_ROR_zpagex:
	GetZPageX
	DoROR(ZPage)
	Continue

	.globl op_ROR_abs
op_ROR_abs:
	GetAbs
	DoROR(Norm)
	Continue

	.globl op_ROR_absx
op_ROR_absx:	
	GetAbsX
	DoROR(Norm)
	Continue

	.globl op_JMP_abs
op_JMP_abs:	
	movw %edx, %edi
	MemReadW(Norm)

#ifdef DEBUG_fc
	pushal

	pushl %eax
	pushl $str_JABS
	call printf
	addl $8, %esp

	popal
#endif

	movw %ax, %dx
	Continue

str_JABS:
	.ascii ") JMP $%04hx\n\0"

str_JIND:
	.ascii ") JMP ($%04hx) -> $%04hx\n\0"

	.globl op_JMP_ind
op_JMP_ind:
 	movl %edx, %edi
	MemReadW(Norm)
#ifdef DEBUG_fc
	movw %ax, %dx
#endif
	incb %al
	movw %ax, %di
	MemReadNorm
	movb %al, %ah
	pushl %eax
	movw %di, %ax
	decb %al
	movw %ax, %di
	popl %eax
	MemReadNorm
	
#ifdef DEBUG_fc
	pushal

	pushl %eax
	pushl %edi
	pushl $str_JIND
	call printf
	addl $0xc, %esp

	popal
#endif

	movw %ax, %dx
	Continue

str_CABS:
	.ascii ") JSR $%04hx\n\0"

str_RTS:
	.ascii ") RTS -> $%04hx\n\0"

	.globl op_JSR_abs
op_JSR_abs:
	GetFromPC_B	/* Trust me, this saves an inc/dec pair on %edi */
	MemReadW(Norm)
	push(%dh)
	push(%dl)

#ifdef DEBUG_fc
	pushal

	pushl %eax
	pushl $str_CABS
	call printf
	addl $8, %esp

	popal
#endif

	movw %ax, %dx
	Continue

	.globl op_RTS
op_RTS:
	pop(%dl)
	pop(%dh)
	inc %edx

#ifdef DEBUG_fc
	pushal

	pushl %edx
	pushl $str_RTS
	call printf
	addl $8, %esp

	popal
#endif

	Continue

	.globl op_PHA
op_PHA:
	movb reg_A, %al
	push(%al)
	Continue
	
	.globl op_PLA
op_PLA:
	pop(%al)
	movb %al, reg_A
	orb %al, %al
	FlagNZ
	Continue

	.globl op_PHP
op_PHP:
	xorl %eax, %eax
	movl $SYMNAME(flags_to_6502), %esi
	movb %ch, %al
	movb (%esi, %eax), %al
	push(%al)
	Continue
	
	.globl op_PLP
op_PLP:	
	pop(%al)
	movzbl %al, %eax
	movl $SYMNAME(flags_to_8088), %esi
	movb (%eax, %esi), %ch
	Continue

	.globl op_NOP
op_NOP:	
	Continue

	.globl op_BRK
op_BRK:
	incw %dx
	push(%dh)
	push(%dl)

	xorl %eax, %eax
	movl $SYMNAME(flags_to_6502), %esi
	movb %ch, %al
	movb (%esi, %eax), %al
	push(%al)

	movl $0xfffe, %edi
	MemReadW(Norm)
	movw %ax, %dx

	Continue

	.globl op_RTI
op_RTI:	
	pop(%al)
	movzbl %al, %eax
	movl $SYMNAME(flags_to_8088), %esi
	movb (%eax, %esi), %ch

	pop(%dl)
	pop(%dh)

	Continue
			
	.globl op_UNIMP
	.globl abort_instr
op_UNIMP:
	decw %dx
	orb $1, SYMNAME(system_flags)
abort_instr:
	movw %dx, reg_PC
/*	movb %cl, reg_A*/
	movb %ch, reg_P
/*	movb %bl, reg_X*/
/*	movb %bh, reg_Y*/

	popal
	
	popl %ebp

	ret

/*
 * $Log: opc6502.S,v $
 * Revision 1.3  1998/12/19 21:04:41  nyef
 * fixed BRK and RTI opcodes
 *
 * Revision 1.2  1998/11/01 23:30:13  nyef
 * fixed all ZPage addressing modes to use direct ZPage access.
 *
 * Revision 1.1  1998/07/11 22:18:56  nyef
 * Initial revision
 *
 */