/*
 * opcz80.S
 *
 * z80 opcode emulation
 */

/* $Id: opcz80.S,v 1.3 1999/06/14 16:50:35 nyef Exp $ */

#include "opcz80.h"

#define op_UNIMP op_Z80_UNIMP
#define op_UNIMP2 op_Z80_UNIMP2

/* opcode map */
	.globl SYMNAME(opcz80_map)
SYMLABEL(opcz80_map)
	.long op_UNIMP		/* 00 */
	.long op_LD_rBC_nn	/* 01 */
	.long op_UNIMP		/* 02 */
	.long op_INC_BC		/* 03 */
	.long op_UNIMP		/* 04 */
	.long op_UNIMP		/* 05 */
	.long op_LD_rB_n	/* 06 */
	.long op_UNIMP		/* 07 */
	.long op_UNIMP		/* 08 */
	.long op_ADD_HL_BC	/* 09 */
	.long op_UNIMP		/* 0A */
	.long op_UNIMP		/* 0B */
	.long op_UNIMP		/* 0C */
	.long op_UNIMP		/* 0D */
	.long op_LD_rC_n	/* 0E */
	.long op_UNIMP		/* 0F */
	.long op_DJNZ		/* 10 */
	.long op_LD_rDE_nn	/* 11 */
	.long op_UNIMP		/* 12 */
	.long op_INC_DE		/* 13 */
	.long op_UNIMP		/* 14 */
	.long op_UNIMP		/* 15 */
	.long op_LD_rD_n	/* 16 */
	.long op_UNIMP		/* 17 */
	.long op_JR_e		/* 18 */
	.long op_ADD_HL_DE	/* 19 */
	.long op_LD_rA_iDE	/* 1A */
	.long op_UNIMP		/* 1B */
	.long op_UNIMP		/* 1C */
	.long op_UNIMP		/* 1D */
	.long op_LD_rE_n	/* 1E */
	.long op_UNIMP		/* 1F */
	.long op_JR_NZ_e	/* 20 */
	.long op_LD_rHL_nn	/* 21 */
	.long op_UNIMP		/* 22 */
	.long op_INC_HL		/* 23 */
	.long op_UNIMP		/* 24 */
	.long op_UNIMP		/* 25 */
	.long op_LD_rH_n	/* 26 */
	.long op_UNIMP		/* 27 */
	.long op_JR_Z_e		/* 28 */
	.long op_ADD_HL_HL	/* 29 */
	.long op_UNIMP		/* 2A */
	.long op_UNIMP		/* 2B */
	.long op_UNIMP		/* 2C */
	.long op_UNIMP		/* 2D */
	.long op_LD_rL_n	/* 2E */
	.long op_UNIMP		/* 2F */
	.long op_UNIMP		/* 30 */
	.long op_LD_rSP_nn	/* 31 */
	.long op_LD_inn_rA	/* 32 */
	.long op_INC_SP		/* 33 */
	.long op_UNIMP		/* 34 */
	.long op_UNIMP		/* 35 */
	.long op_LD_iHL_n	/* 36 */
	.long op_UNIMP		/* 37 */
	.long op_UNIMP		/* 38 */
	.long op_ADD_HL_SP	/* 39 */
	.long op_LD_rA_inn	/* 3A */
	.long op_UNIMP		/* 3B */
	.long op_UNIMP		/* 3C */
	.long op_UNIMP		/* 3D */
	.long op_LD_rA_n	/* 3E */
	.long op_UNIMP		/* 3F */
	.long op_LD_rB_rB	/* 40 */
	.long op_LD_rB_rC	/* 41 */
	.long op_LD_rB_rD	/* 42 */
	.long op_LD_rB_rE	/* 43 */
	.long op_LD_rB_rF	/* 44 */
	.long op_LD_rB_rL	/* 45 */
	.long op_UNIMP		/* 46 */
	.long op_LD_rB_rA	/* 47 */
	.long op_LD_rC_rB	/* 48 */
	.long op_LD_rC_rC	/* 49 */
	.long op_LD_rC_rD	/* 4A */
	.long op_LD_rC_rE	/* 4B */
	.long op_LD_rC_rF	/* 4C */
	.long op_LD_rC_rL	/* 4D */
	.long op_UNIMP		/* 4E */
	.long op_LD_rC_rA	/* 4F */
	.long op_LD_rD_rB	/* 50 */
	.long op_LD_rD_rC	/* 51 */
	.long op_LD_rD_rD	/* 52 */
	.long op_LD_rD_rE	/* 53 */
	.long op_LD_rD_rF	/* 54 */
	.long op_LD_rD_rL	/* 55 */
	.long op_UNIMP		/* 56 */
	.long op_LD_rD_rA	/* 57 */
	.long op_LD_rE_rB	/* 58 */
	.long op_LD_rE_rC	/* 59 */
	.long op_LD_rE_rD	/* 5A */
	.long op_LD_rE_rE	/* 5B */
	.long op_LD_rE_rF	/* 5C */
	.long op_LD_rE_rL	/* 5D */
	.long op_UNIMP		/* 5E */
	.long op_LD_rE_rA	/* 5F */
	.long op_LD_rH_rB	/* 60 */
	.long op_LD_rH_rC	/* 61 */
	.long op_LD_rH_rD	/* 62 */
	.long op_LD_rH_rE	/* 63 */
	.long op_LD_rH_rF	/* 64 */
	.long op_LD_rH_rL	/* 65 */
	.long op_UNIMP		/* 66 */
	.long op_LD_rH_rA	/* 67 */
	.long op_LD_rL_rB	/* 68 */
	.long op_LD_rL_rC	/* 69 */
	.long op_LD_rL_rD	/* 6A */
	.long op_LD_rL_rE	/* 6B */
	.long op_LD_rL_rF	/* 6C */
	.long op_LD_rL_rL	/* 6D */
	.long op_UNIMP		/* 6E */
	.long op_LD_rL_rA	/* 6F */
	.long op_LD_iHL_rB	/* 70 */
	.long op_LD_iHL_rC	/* 71 */
	.long op_LD_iHL_rD	/* 72 */
	.long op_LD_iHL_rE	/* 73 */
	.long op_LD_iHL_rH	/* 74 */
	.long op_LD_iHL_rL	/* 75 */
	.long op_UNIMP		/* 76 */
	.long op_LD_iHL_rA	/* 77 */
	.long op_LD_rA_rB	/* 78 */
	.long op_LD_rA_rC	/* 79 */
	.long op_LD_rA_rD	/* 7A */
	.long op_LD_rA_rE	/* 7B */
	.long op_LD_rA_rF	/* 7C */
	.long op_LD_rA_rL	/* 7D */
	.long op_UNIMP		/* 7E */
	.long op_LD_rA_rA	/* 7F */
	.long op_UNIMP		/* 80 */
	.long op_UNIMP		/* 81 */
	.long op_UNIMP		/* 82 */
	.long op_UNIMP		/* 83 */
	.long op_UNIMP		/* 84 */
	.long op_UNIMP		/* 85 */
	.long op_UNIMP		/* 86 */
	.long op_UNIMP		/* 87 */
	.long op_UNIMP		/* 88 */
	.long op_UNIMP		/* 89 */
	.long op_UNIMP		/* 8A */
	.long op_UNIMP		/* 8B */
	.long op_UNIMP		/* 8C */
	.long op_UNIMP		/* 8D */
	.long op_UNIMP		/* 8E */
	.long op_UNIMP		/* 8F */
	.long op_UNIMP		/* 90 */
	.long op_UNIMP		/* 91 */
	.long op_UNIMP		/* 92 */
	.long op_UNIMP		/* 93 */
	.long op_UNIMP		/* 94 */
	.long op_UNIMP		/* 95 */
	.long op_UNIMP		/* 96 */
	.long op_UNIMP		/* 97 */
	.long op_SBC_B		/* 98 */
	.long op_SBC_C		/* 99 */
	.long op_SBC_D		/* 9A */
	.long op_SBC_E		/* 9B */
	.long op_SBC_H		/* 9C */
	.long op_SBC_L		/* 9D */
	.long op_UNIMP		/* 9E */
	.long op_SBC_A		/* 9F */
	.long op_UNIMP		/* A0 */
	.long op_UNIMP		/* A1 */
	.long op_UNIMP		/* A2 */
	.long op_UNIMP		/* A3 */
	.long op_UNIMP		/* A4 */
	.long op_UNIMP		/* A5 */
	.long op_UNIMP		/* A6 */
	.long op_UNIMP		/* A7 */
	.long op_UNIMP		/* A8 */
	.long op_UNIMP		/* A9 */
	.long op_UNIMP		/* AA */
	.long op_UNIMP		/* AB */
	.long op_UNIMP		/* AC */
	.long op_UNIMP		/* AD */
	.long op_UNIMP		/* AE */
	.long op_XOR_A		/* AF */
	.long op_UNIMP		/* B0 */
	.long op_UNIMP		/* B1 */
	.long op_UNIMP		/* B2 */
	.long op_UNIMP		/* B3 */
	.long op_UNIMP		/* B4 */
	.long op_UNIMP		/* B5 */
	.long op_UNIMP		/* B6 */
	.long op_OR_A		/* B7 */
	.long op_UNIMP		/* B8 */
	.long op_UNIMP		/* B9 */
	.long op_UNIMP		/* BA */
	.long op_UNIMP		/* BB */
	.long op_UNIMP		/* BC */
	.long op_UNIMP		/* BD */
	.long op_UNIMP		/* BE */
	.long op_UNIMP		/* BF */
	.long op_UNIMP		/* C0 */
	.long op_POP_BC		/* C1 */
	.long op_JP_NZ_nn	/* C2 */
	.long op_JP_nn		/* C3 */
	.long op_UNIMP		/* C4 */
	.long op_PUSH_BC	/* C5 */
	.long op_UNIMP		/* C6 */
	.long op_UNIMP		/* C7 */
	.long op_UNIMP		/* C8 */
	.long op_RET		/* C9 */
	.long op_JP_Z_nn	/* CA */
	.long op_UNIMP		/* CB */
	.long op_UNIMP		/* CC */
	.long op_CALL_nn	/* CD */
	.long op_UNIMP		/* CE */
	.long op_UNIMP		/* CF */
	.long op_UNIMP		/* D0 */
	.long op_POP_DE		/* D1 */
	.long op_JP_NC_nn	/* D2 */
	.long op_UNIMP		/* D3 */
	.long op_UNIMP		/* D4 */
	.long op_PUSH_DE	/* D5 */
	.long op_UNIMP		/* D6 */
	.long op_UNIMP		/* D7 */
	.long op_UNIMP		/* D8 */
	.long op_UNIMP		/* D9 */
	.long op_JP_C_nn	/* DA */
	.long op_IN_rA_n	/* DB */
	.long op_UNIMP		/* DC */
	.long op_UNIMP		/* DD */
	.long op_UNIMP		/* DE */
	.long op_UNIMP		/* DF */
	.long op_UNIMP		/* E0 */
	.long op_POP_HL		/* E1 */
	.long op_JP_PO_nn	/* E2 */
	.long op_UNIMP		/* E3 */
	.long op_UNIMP		/* E4 */
	.long op_PUSH_HL	/* E5 */
	.long op_UNIMP		/* E6 */
	.long op_UNIMP		/* E7 */
	.long op_UNIMP		/* E8 */
	.long op_UNIMP		/* E9 */
	.long op_JP_PE_nn	/* EA */
	.long op_UNIMP		/* EB */
	.long op_UNIMP		/* EC */
	.long op_ED_prefix	/* ED */
	.long op_UNIMP		/* EE */
	.long op_UNIMP		/* EF */
	.long op_UNIMP		/* F0 */
	.long op_POP_AF		/* F1 */
	.long op_JP_P_nn	/* F2 */
	.long op_DI		/* F3 */
	.long op_UNIMP		/* F4 */
	.long op_PUSH_AF	/* F5 */
	.long op_UNIMP		/* F6 */
	.long op_UNIMP		/* F7 */
	.long op_UNIMP		/* F8 */
	.long op_UNIMP		/* F9 */
	.long op_JP_M_nn	/* FA */
	.long op_UNIMP		/* FB */
	.long op_UNIMP		/* FC */
	.long op_UNIMP		/* FD */
	.long op_UNIMP		/* FE */
	.long op_UNIMP		/* FF */

	.globl SYMNAME(opcz80_ed_map)
SYMLABEL(opcz80_ed_map)
	.long op_UNIMP2		/* 00 */
	.long op_UNIMP2		/* 01 */
	.long op_UNIMP2		/* 02 */
	.long op_UNIMP2		/* 03 */
	.long op_UNIMP2		/* 04 */
	.long op_UNIMP2		/* 05 */
	.long op_UNIMP2		/* 06 */
	.long op_UNIMP2		/* 07 */
	.long op_UNIMP2		/* 08 */
	.long op_UNIMP2		/* 09 */
	.long op_UNIMP2		/* 0A */
	.long op_UNIMP2		/* 0B */
	.long op_UNIMP2		/* 0C */
	.long op_UNIMP2		/* 0D */
	.long op_UNIMP2		/* 0E */
	.long op_UNIMP2		/* 0F */
	.long op_UNIMP2		/* 10 */
	.long op_UNIMP2		/* 11 */
	.long op_UNIMP2		/* 12 */
	.long op_UNIMP2		/* 13 */
	.long op_UNIMP2		/* 14 */
	.long op_UNIMP2		/* 15 */
	.long op_UNIMP2		/* 16 */
	.long op_UNIMP2		/* 17 */
	.long op_UNIMP2		/* 18 */
	.long op_UNIMP2		/* 19 */
	.long op_UNIMP2		/* 1A */
	.long op_UNIMP2		/* 1B */
	.long op_UNIMP2		/* 1C */
	.long op_UNIMP2		/* 1D */
	.long op_UNIMP2		/* 1E */
	.long op_UNIMP2		/* 1F */
	.long op_UNIMP2		/* 20 */
	.long op_UNIMP2		/* 21 */
	.long op_UNIMP2		/* 22 */
	.long op_UNIMP2		/* 23 */
	.long op_UNIMP2		/* 24 */
	.long op_UNIMP2		/* 25 */
	.long op_UNIMP2		/* 26 */
	.long op_UNIMP2		/* 27 */
	.long op_UNIMP2		/* 28 */
	.long op_UNIMP2		/* 29 */
	.long op_UNIMP2		/* 2A */
	.long op_UNIMP2		/* 2B */
	.long op_UNIMP2		/* 2C */
	.long op_UNIMP2		/* 2D */
	.long op_UNIMP2		/* 2E */
	.long op_UNIMP2		/* 2F */
	.long op_UNIMP2		/* 30 */
	.long op_UNIMP2		/* 31 */
	.long op_UNIMP2		/* 32 */
	.long op_UNIMP2		/* 33 */
	.long op_UNIMP2		/* 34 */
	.long op_UNIMP2		/* 35 */
	.long op_UNIMP2		/* 36 */
	.long op_UNIMP2		/* 37 */
	.long op_UNIMP2		/* 38 */
	.long op_UNIMP2		/* 39 */
	.long op_UNIMP2		/* 3A */
	.long op_UNIMP2		/* 3B */
	.long op_UNIMP2		/* 3C */
	.long op_UNIMP2		/* 3D */
	.long op_UNIMP2		/* 3E */
	.long op_UNIMP2		/* 3F */
	.long op_UNIMP2		/* 40 */
	.long op_UNIMP2		/* 41 */
	.long op_SBC_HL_BC	/* 42 */
	.long op_UNIMP2		/* 43 */
	.long op_UNIMP2		/* 44 */
	.long op_UNIMP2		/* 45 */
	.long op_UNIMP2		/* 46 */
	.long op_UNIMP2		/* 47 */
	.long op_UNIMP2		/* 48 */
	.long op_UNIMP2		/* 49 */
	.long op_ADC_HL_BC	/* 4A */
	.long op_UNIMP2		/* 4B */
	.long op_UNIMP2		/* 4C */
	.long op_UNIMP2		/* 4D */
	.long op_UNIMP2		/* 4E */
	.long op_UNIMP2		/* 4F */
	.long op_UNIMP2		/* 50 */
	.long op_UNIMP2		/* 51 */
	.long op_SBC_HL_DE	/* 52 */
	.long op_UNIMP2		/* 53 */
	.long op_UNIMP2		/* 54 */
	.long op_UNIMP2		/* 55 */
	.long op_IM1		/* 56 */
	.long op_UNIMP2		/* 57 */
	.long op_UNIMP2		/* 58 */
	.long op_UNIMP2		/* 59 */
	.long op_ADC_HL_DE	/* 5A */
	.long op_UNIMP2		/* 5B */
	.long op_UNIMP2		/* 5C */
	.long op_UNIMP2		/* 5D */
	.long op_UNIMP2		/* 5E */
	.long op_UNIMP2		/* 5F */
	.long op_UNIMP2		/* 60 */
	.long op_UNIMP2		/* 61 */
	.long op_SBC_HL_HL	/* 62 */
	.long op_UNIMP2		/* 63 */
	.long op_UNIMP2		/* 64 */
	.long op_UNIMP2		/* 65 */
	.long op_UNIMP2		/* 66 */
	.long op_UNIMP2		/* 67 */
	.long op_UNIMP2		/* 68 */
	.long op_UNIMP2		/* 69 */
	.long op_ADC_HL_HL	/* 6A */
	.long op_UNIMP2		/* 6B */
	.long op_UNIMP2		/* 6C */
	.long op_UNIMP2		/* 6D */
	.long op_UNIMP2		/* 6E */
	.long op_UNIMP2		/* 6F */
	.long op_UNIMP2		/* 70 */
	.long op_UNIMP2		/* 71 */
	.long op_SBC_HL_SP	/* 72 */
	.long op_UNIMP2		/* 73 */
	.long op_UNIMP2		/* 74 */
	.long op_UNIMP2		/* 75 */
	.long op_UNIMP2		/* 76 */
	.long op_UNIMP2		/* 77 */
	.long op_UNIMP2		/* 78 */
	.long op_UNIMP2		/* 79 */
	.long op_ADC_HL_SP	/* 7A */
	.long op_UNIMP2		/* 7B */
	.long op_UNIMP2		/* 7C */
	.long op_UNIMP2		/* 7D */
	.long op_UNIMP2		/* 7E */
	.long op_UNIMP2		/* 7F */
	.long op_UNIMP2		/* 80 */
	.long op_UNIMP2		/* 81 */
	.long op_UNIMP2		/* 82 */
	.long op_UNIMP2		/* 83 */
	.long op_UNIMP2		/* 84 */
	.long op_UNIMP2		/* 85 */
	.long op_UNIMP2		/* 86 */
	.long op_UNIMP2		/* 87 */
	.long op_UNIMP2		/* 88 */
	.long op_UNIMP2		/* 89 */
	.long op_UNIMP2		/* 8A */
	.long op_UNIMP2		/* 8B */
	.long op_UNIMP2		/* 8C */
	.long op_UNIMP2		/* 8D */
	.long op_UNIMP2		/* 8E */
	.long op_UNIMP2		/* 8F */
	.long op_UNIMP2		/* 90 */
	.long op_UNIMP2		/* 91 */
	.long op_UNIMP2		/* 92 */
	.long op_UNIMP2		/* 93 */
	.long op_UNIMP2		/* 94 */
	.long op_UNIMP2		/* 95 */
	.long op_UNIMP2		/* 96 */
	.long op_UNIMP2		/* 97 */
	.long op_UNIMP2		/* 98 */
	.long op_UNIMP2		/* 99 */
	.long op_UNIMP2		/* 9A */
	.long op_UNIMP2		/* 9B */
	.long op_UNIMP2		/* 9C */
	.long op_UNIMP2		/* 9D */
	.long op_UNIMP2		/* 9E */
	.long op_UNIMP2		/* 9F */
	.long op_UNIMP2		/* A0 */
	.long op_CPI		/* A1 */
	.long op_UNIMP2		/* A2 */
	.long op_UNIMP2		/* A3 */
	.long op_UNIMP2		/* A4 */
	.long op_UNIMP2		/* A5 */
	.long op_UNIMP2		/* A6 */
	.long op_UNIMP2		/* A7 */
	.long op_UNIMP2		/* A8 */
	.long op_UNIMP2		/* A9 */
	.long op_UNIMP2		/* AA */
	.long op_UNIMP2		/* AB */
	.long op_UNIMP2		/* AC */
	.long op_UNIMP2		/* AD */
	.long op_UNIMP2		/* AE */
	.long op_UNIMP2		/* AF */
	.long op_LDIR		/* B0 */
	.long op_UNIMP2		/* B1 */
	.long op_UNIMP2		/* B2 */
	.long op_OTIR		/* B3 */
	.long op_UNIMP2		/* B4 */
	.long op_UNIMP2		/* B5 */
	.long op_UNIMP2		/* B6 */
	.long op_UNIMP2		/* B7 */
	.long op_UNIMP2		/* B8 */
	.long op_UNIMP2		/* B9 */
	.long op_UNIMP2		/* BA */
	.long op_UNIMP2		/* BB */
	.long op_UNIMP2		/* BC */
	.long op_UNIMP2		/* BD */
	.long op_UNIMP2		/* BE */
	.long op_UNIMP2		/* BF */
	.long op_UNIMP2		/* C0 */
	.long op_UNIMP2		/* C1 */
	.long op_UNIMP2		/* C2 */
	.long op_UNIMP2		/* C3 */
	.long op_UNIMP2		/* C4 */
	.long op_UNIMP2		/* C5 */
	.long op_UNIMP2		/* C6 */
	.long op_UNIMP2		/* C7 */
	.long op_UNIMP2		/* C8 */
	.long op_UNIMP2		/* C9 */
	.long op_UNIMP2		/* CA */
	.long op_UNIMP2		/* CB */
	.long op_UNIMP2		/* CC */
	.long op_UNIMP2		/* CD */
	.long op_UNIMP2		/* CE */
	.long op_UNIMP2		/* CF */
	.long op_UNIMP2		/* D0 */
	.long op_UNIMP2		/* D1 */
	.long op_UNIMP2		/* D2 */
	.long op_UNIMP2		/* D3 */
	.long op_UNIMP2		/* D4 */
	.long op_UNIMP2		/* D5 */
	.long op_UNIMP2		/* D6 */
	.long op_UNIMP2		/* D7 */
	.long op_UNIMP2		/* D8 */
	.long op_UNIMP2		/* D9 */
	.long op_UNIMP2		/* DA */
	.long op_UNIMP2		/* DB */
	.long op_UNIMP2		/* DC */
	.long op_UNIMP2		/* DD */
	.long op_UNIMP2		/* DE */
	.long op_UNIMP2		/* DF */
	.long op_UNIMP2		/* E0 */
	.long op_UNIMP2		/* E1 */
	.long op_UNIMP2		/* E2 */
	.long op_UNIMP2		/* E3 */
	.long op_UNIMP2		/* E4 */
	.long op_UNIMP2		/* E5 */
	.long op_UNIMP2		/* E6 */
	.long op_UNIMP2		/* E7 */
	.long op_UNIMP2		/* E8 */
	.long op_UNIMP2		/* E9 */
	.long op_UNIMP2		/* EA */
	.long op_UNIMP2		/* EB */
	.long op_UNIMP2		/* EC */
	.long op_UNIMP2		/* ED */
	.long op_UNIMP2		/* EE */
	.long op_UNIMP2		/* EF */
	.long op_UNIMP2		/* F0 */
	.long op_UNIMP2		/* F1 */
	.long op_UNIMP2		/* F2 */
	.long op_UNIMP2		/* F3 */
	.long op_UNIMP2		/* F4 */
	.long op_UNIMP2		/* F5 */
	.long op_UNIMP2		/* F6 */
	.long op_UNIMP2		/* F7 */
	.long op_UNIMP2		/* F8 */
	.long op_UNIMP2		/* F9 */
	.long op_UNIMP2		/* FA */
	.long op_UNIMP2		/* FB */
	.long op_UNIMP2		/* FC */
	.long op_UNIMP2		/* FD */
	.long op_UNIMP2		/* FE */
	.long op_UNIMP2		/* FF */

	.globl op_ED_prefix
op_ED_prefix:
	GetFromPC_B
	MemRead
	movzbl %al, %eax
	jmp *SYMNAME(opcz80_ed_map)(,%eax,4)

	.globl op_IM1
op_IM1:
	/* FIXME: interrupt mode support? */
	Continue
	
	.globl op_DI
op_DI:
	/* FIXME: disable interrupts */
	Continue

	.globl op_OTIR
op_OTIR:
	/* FIXME: flags? */
	xorl %edi, %edi
	movw reg_HL, %di
	MemRead
	decb reg_B
	/* FIXME: pushal/popal is overkill */
	pushal
	pushl %eax
	movzwl reg_BC, %eax
	pushl %eax
	pushl user
	call *io_write
	addl $12, %esp
	popal
	decw reg_HL
	movb reg_B, %al
	orb %al, %al
	jz 0f
	decw %dx
	decw %dx
0:	Continue

	.globl op_CPI
op_CPI:
	movw reg_HL, %di
	MemRead
	cmpb %al, reg_A
	FlagSZHVC
	incw reg_HL
	decw reg_BC
	FlagV
	Continue

	.globl op_IN_rA_n
op_IN_rA_n:
	GetFromPC_B
	MemRead
	movb reg_A, %ah
	pushal
	pushl %eax
	pushl user
	call *io_read
	addl $8, %esp
	movb %al, reg_A
	popal
	Continue

	.globl op_XOR_A
op_XOR_A:
	movb reg_A, %al
	xorb %al, reg_A
	FlagSZHVC
	andb flag_H_not, %ch
	Continue

	.globl op_OR_A
op_OR_A:
	movb reg_A, %al
	orb %al, reg_A
	FlagSZHVC
	andb flag_H_not, %ch
	Continue

	.globl op_SBC_B
op_SBC_B:
	bt flag_C_bit, %ecx
	movb reg_B, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_SBC_C
op_SBC_C:
	bt flag_C_bit, %ecx
	movb reg_C, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_SBC_D
op_SBC_D:
	bt flag_C_bit, %ecx
	movb reg_D, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_SBC_E
op_SBC_E:
	bt flag_C_bit, %ecx
	movb reg_E, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_SBC_H
op_SBC_H:
	bt flag_C_bit, %ecx
	movb reg_H, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_SBC_L
op_SBC_L:
	bt flag_C_bit, %ecx
	movb reg_L, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_SBC_A
op_SBC_A:
	bt flag_C_bit, %ecx
	movb reg_A, %al
	sbbb %al, reg_A
	FlagSZHVC
	Continue

	.globl op_ADD_HL_BC
op_ADD_HL_BC:
	movb reg_C, %al
	movb reg_B, %bl
	addb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADD_HL_DE
op_ADD_HL_DE:
	movb reg_E, %al
	movb reg_D, %bl
	addb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADD_HL_HL
op_ADD_HL_HL:
	movb reg_L, %al
	movb reg_H, %bl
	addb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADD_HL_SP
op_ADD_HL_SP:
	movb reg_P, %al
	movb reg_S, %bl
	addb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADC_HL_BC
op_ADC_HL_BC:
	bt flag_C_bit, %ecx
	movb reg_C, %al
	movb reg_B, %bl
	adcb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADC_HL_DE
op_ADC_HL_DE:
	bt flag_C_bit, %ecx
	movb reg_E, %al
	movb reg_D, %bl
	adcb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADC_HL_HL
op_ADC_HL_HL:
	bt flag_C_bit, %ecx
	movb reg_L, %al
	movb reg_H, %bl
	adcb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_ADC_HL_SP
op_ADC_HL_SP:
	bt flag_C_bit, %ecx
	movb reg_P, %al
	movb reg_S, %bl
	adcb %al, reg_L
	adcb %bl, reg_H
	FlagHC
	Continue

	.globl op_SBC_HL_BC
op_SBC_HL_BC:
	bt flag_C_bit, %ecx
	movb reg_C, %al
	movb reg_B, %bl
	sbbb %al, reg_L
	sbbb %bl, reg_H
	FlagHC
	Continue

	.globl op_SBC_HL_DE
op_SBC_HL_DE:
	bt flag_C_bit, %ecx
	movb reg_E, %al
	movb reg_D, %bl
	sbbb %al, reg_L
	sbbb %bl, reg_H
	FlagHC
	Continue

	.globl op_SBC_HL_HL
op_SBC_HL_HL:
	bt flag_C_bit, %ecx
	movb reg_L, %al
	movb reg_H, %bl
	sbbb %al, reg_L
	sbbb %bl, reg_H
	FlagHC
	Continue

	.globl op_SBC_HL_SP
op_SBC_HL_SP:
	bt flag_C_bit, %ecx
	movb reg_P, %al
	movb reg_S, %bl
	sbbb %al, reg_L
	sbbb %bl, reg_H
	FlagHC
	Continue

	.globl op_JR_e
op_JR_e:
	GetFromPC_B
	MemRead
	cbw
	addw %ax, %dx
	Continue

	.globl op_JR_NZ_e
op_JR_NZ_e:
	GetFromPC_B
	MemRead
	bt flag_Z_bit, %ecx
	jnc 0f
	cbw
	addw %ax, %dx
0:	Continue

	.globl op_JR_Z_e
op_JR_Z_e:
	GetFromPC_B
	MemRead
	bt flag_Z_bit, %ecx
	jc 0f
	cbw
	addw %ax, %dx
0:	Continue

	.globl op_JP_NZ_nn
op_JP_NZ_nn:
	GetFromPC_W
	MemReadW
	bt flag_Z_bit, %ecx
	jnc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_Z_nn
op_JP_Z_nn:
	GetFromPC_W
	MemReadW
	bt flag_Z_bit, %ecx
	jc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_NC_nn
op_JP_NC_nn:
	GetFromPC_W
	MemReadW
	bt flag_C_bit, %ecx
	jnc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_C_nn
op_JP_C_nn:
	GetFromPC_W
	MemReadW
	bt flag_C_bit, %ecx
	jc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_PO_nn
op_JP_PO_nn:
	GetFromPC_W
	MemReadW
	bt flag_V_bit, %ecx
	jnc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_PE_nn
op_JP_PE_nn:
	GetFromPC_W
	MemReadW
	bt flag_V_bit, %ecx
	jc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_P_nn
op_JP_P_nn:
	GetFromPC_W
	MemReadW
	bt flag_S_bit, %ecx
	jnc 0f
	movw %ax, %dx
0:	Continue

	.globl op_JP_M_nn
op_JP_M_nn:
	GetFromPC_W
	MemReadW
	bt flag_S_bit, %ecx
	jc 0f
	movw %ax, %dx
0:	Continue

	.globl op_INC_BC
op_INC_BC:
	incw reg_BC
	Continue

	.globl op_INC_DE
op_INC_DE:
	incw reg_DE
	Continue

	.globl op_INC_HL
op_INC_HL:
	incw reg_HL
	Continue

	.globl op_INC_SP
op_INC_SP:
	incw reg_SP
	Continue

	.globl op_LDIR
op_LDIR:
	xorl %edi, %edi
	movw reg_HL, %di
	MemRead
	movw reg_DE, %di
	MemWrite
	decw reg_BC
	jz 0f
	subw $2, %dx
0:	Continue

	.globl op_DJNZ
op_DJNZ:
	GetFromPC_B
	MemRead
	decw reg_BC
	jz 0f
	cbw
	addw %ax, %dx
0:	Continue

	.globl op_PUSH_BC
op_PUSH_BC:
	push(reg_B)
	push(reg_C)
	Continue

	.globl op_PUSH_DE
op_PUSH_DE:
	push(reg_D)
	push(reg_E)
	Continue

	.globl op_PUSH_HL
op_PUSH_HL:
	push(reg_H)
	push(reg_L)
	Continue

	.globl op_PUSH_AF
op_PUSH_AF:
	push(reg_A)
	push(reg_F)
	Continue

	.globl op_POP_BC
op_POP_BC:
	pop(reg_C)
	pop(reg_B)
	Continue

	.globl op_POP_DE
op_POP_DE:
	pop(reg_E)
	pop(reg_D)
	Continue

	.globl op_POP_HL
op_POP_HL:
	pop(reg_L)
	pop(reg_H)
	Continue

	.globl op_POP_AF
op_POP_AF:
	pop(reg_F)
	pop(reg_A)
	Continue

	.globl op_CALL_nn
op_CALL_nn:
	GetFromPC_W
	MemReadW
	pushl %eax
	push(%dh)
	push(%dl)
	popl %eax
	movw %ax, %dx
	Continue

	.globl op_RET
op_RET:
	pop(%dl)
	pop(%dh)
	Continue

	.globl op_JP_nn
op_JP_nn:
	GetFromPC_W
	MemReadW
	movw %ax, %dx
	Continue

	.globl op_LD_iHL_rB
op_LD_iHL_rB:
	xorl %edi, %edi
	movb reg_B, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_rC
op_LD_iHL_rC:
	xorl %edi, %edi
	movb reg_C, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_rD
op_LD_iHL_rD:
	xorl %edi, %edi
	movb reg_D, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_rE
op_LD_iHL_rE:
	xorl %edi, %edi
	movb reg_E, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_rH
op_LD_iHL_rH:
	xorl %edi, %edi
	movb reg_H, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_rL
op_LD_iHL_rL:
	xorl %edi, %edi
	movb reg_L, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_rA
op_LD_iHL_rA:
	xorl %edi, %edi
	movb reg_A, %al
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_iHL_n
op_LD_iHL_n:
	GetFromPC_B
	MemRead
	xorl %edi, %edi
	movw reg_HL, %di
	MemWrite
	Continue

	.globl op_LD_rA_inn
op_LD_rA_inn:
	GetFromPC_W
	MemReadW
	movw %ax, %di
	MemRead
	movb %al, reg_A
	Continue

	.globl op_LD_rA_iDE
op_LD_rA_iDE:
	movw reg_DE, %di
	MemRead
	movb %al, reg_A
	Continue

	.globl op_LD_inn_rA
op_LD_inn_rA:
	GetFromPC_W
	MemReadW
	movw %ax, %di
	movb reg_A, %al
	MemWrite
	Continue

	.globl op_LD_rBC_nn
op_LD_rBC_nn:
	GetFromPC_W
	MemReadW
	movw %ax, reg_BC
	Continue
	
	.globl op_LD_rDE_nn
op_LD_rDE_nn:
	GetFromPC_W
	MemReadW
	movw %ax, reg_DE
	Continue
	
	.globl op_LD_rHL_nn
op_LD_rHL_nn:
	GetFromPC_W
	MemReadW
	movw %ax, reg_HL
	Continue
	
	.globl op_LD_rSP_nn
op_LD_rSP_nn:
	GetFromPC_W
	MemReadW
	movw %ax, reg_SP
	Continue

	.globl op_LD_rB_n
op_LD_rB_n:
	GetFromPC_B
	MemRead
	movb %al, reg_B
	Continue

	.globl op_LD_rC_n
op_LD_rC_n:
	GetFromPC_B
	MemRead
	movb %al, reg_C
	Continue

	.globl op_LD_rD_n
op_LD_rD_n:
	GetFromPC_B
	MemRead
	movb %al, reg_D
	Continue

	.globl op_LD_rE_n
op_LD_rE_n:
	GetFromPC_B
	MemRead
	movb %al, reg_E
	Continue

	.globl op_LD_rH_n
op_LD_rH_n:
	GetFromPC_B
	MemRead
	movb %al, reg_H
	Continue

	.globl op_LD_rL_n
op_LD_rL_n:
	GetFromPC_B
	MemRead
	movb %al, reg_L
	Continue

	.globl op_LD_rA_n
op_LD_rA_n:
	GetFromPC_B
	MemRead
	movb %al, reg_A
	Continue

	.globl op_LD_rB_rB
op_LD_rB_rB:
	movb %al, reg_B
	movb reg_B, %al
	Continue

	.globl op_LD_rB_rC
op_LD_rB_rC:
	movb %al, reg_C
	movb reg_B, %al
	Continue

	.globl op_LD_rB_rD
op_LD_rB_rD:
	movb %al, reg_D
	movb reg_B, %al
	Continue

	.globl op_LD_rB_rE
op_LD_rB_rE:
	movb %al, reg_E
	movb reg_B, %al
	Continue

	.globl op_LD_rB_rF
op_LD_rB_rF:
	movb %al, reg_F
	movb reg_B, %al
	Continue

	.globl op_LD_rB_rL
op_LD_rB_rL:
	movb %al, reg_L
	movb reg_B, %al
	Continue

	.globl op_LD_rB_rA
op_LD_rB_rA:
	movb %al, reg_A
	movb reg_B, %al
	Continue

	.globl op_LD_rC_rB
op_LD_rC_rB:
	movb %al, reg_B
	movb reg_C, %al
	Continue

	.globl op_LD_rC_rC
op_LD_rC_rC:
	movb %al, reg_C
	movb reg_C, %al
	Continue

	.globl op_LD_rC_rD
op_LD_rC_rD:
	movb %al, reg_D
	movb reg_C, %al
	Continue

	.globl op_LD_rC_rE
op_LD_rC_rE:
	movb %al, reg_E
	movb reg_C, %al
	Continue

	.globl op_LD_rC_rF
op_LD_rC_rF:
	movb %al, reg_F
	movb reg_C, %al
	Continue

	.globl op_LD_rC_rL
op_LD_rC_rL:
	movb %al, reg_L
	movb reg_C, %al
	Continue

	.globl op_LD_rC_rA
op_LD_rC_rA:
	movb %al, reg_A
	movb reg_C, %al
	Continue

	.globl op_LD_rD_rB
op_LD_rD_rB:
	movb %al, reg_B
	movb reg_D, %al
	Continue

	.globl op_LD_rD_rC
op_LD_rD_rC:
	movb %al, reg_C
	movb reg_D, %al
	Continue

	.globl op_LD_rD_rD
op_LD_rD_rD:
	movb %al, reg_D
	movb reg_D, %al
	Continue

	.globl op_LD_rD_rE
op_LD_rD_rE:
	movb %al, reg_E
	movb reg_D, %al
	Continue

	.globl op_LD_rD_rF
op_LD_rD_rF:
	movb %al, reg_F
	movb reg_D, %al
	Continue

	.globl op_LD_rD_rL
op_LD_rD_rL:
	movb %al, reg_L
	movb reg_D, %al
	Continue

	.globl op_LD_rD_rA
op_LD_rD_rA:
	movb %al, reg_A
	movb reg_D, %al
	Continue

	.globl op_LD_rE_rB
op_LD_rE_rB:
	movb %al, reg_B
	movb reg_E, %al
	Continue

	.globl op_LD_rE_rC
op_LD_rE_rC:
	movb %al, reg_C
	movb reg_E, %al
	Continue

	.globl op_LD_rE_rD
op_LD_rE_rD:
	movb %al, reg_D
	movb reg_E, %al
	Continue

	.globl op_LD_rE_rE
op_LD_rE_rE:
	movb %al, reg_E
	movb reg_E, %al
	Continue

	.globl op_LD_rE_rF
op_LD_rE_rF:
	movb %al, reg_F
	movb reg_E, %al
	Continue

	.globl op_LD_rE_rL
op_LD_rE_rL:
	movb %al, reg_L
	movb reg_E, %al
	Continue

	.globl op_LD_rE_rA
op_LD_rE_rA:
	movb %al, reg_A
	movb reg_E, %al
	Continue

	.globl op_LD_rH_rB
op_LD_rH_rB:
	movb %al, reg_B
	movb reg_H, %al
	Continue

	.globl op_LD_rH_rC
op_LD_rH_rC:
	movb %al, reg_C
	movb reg_H, %al
	Continue

	.globl op_LD_rH_rD
op_LD_rH_rD:
	movb %al, reg_D
	movb reg_H, %al
	Continue

	.globl op_LD_rH_rE
op_LD_rH_rE:
	movb %al, reg_E
	movb reg_H, %al
	Continue

	.globl op_LD_rH_rF
op_LD_rH_rF:
	movb %al, reg_F
	movb reg_H, %al
	Continue

	.globl op_LD_rH_rL
op_LD_rH_rL:
	movb %al, reg_L
	movb reg_H, %al
	Continue

	.globl op_LD_rH_rA
op_LD_rH_rA:
	movb %al, reg_A
	movb reg_H, %al
	Continue

	.globl op_LD_rL_rB
op_LD_rL_rB:
	movb %al, reg_B
	movb reg_L, %al
	Continue

	.globl op_LD_rL_rC
op_LD_rL_rC:
	movb %al, reg_C
	movb reg_L, %al
	Continue

	.globl op_LD_rL_rD
op_LD_rL_rD:
	movb %al, reg_D
	movb reg_L, %al
	Continue

	.globl op_LD_rL_rE
op_LD_rL_rE:
	movb %al, reg_E
	movb reg_L, %al
	Continue

	.globl op_LD_rL_rF
op_LD_rL_rF:
	movb %al, reg_F
	movb reg_L, %al
	Continue

	.globl op_LD_rL_rL
op_LD_rL_rL:
	movb %al, reg_L
	movb reg_L, %al
	Continue

	.globl op_LD_rL_rA
op_LD_rL_rA:
	movb %al, reg_A
	movb reg_L, %al
	Continue

	.globl op_LD_rA_rB
op_LD_rA_rB:
	movb %al, reg_B
	movb reg_A, %al
	Continue

	.globl op_LD_rA_rC
op_LD_rA_rC:
	movb %al, reg_C
	movb reg_A, %al
	Continue

	.globl op_LD_rA_rD
op_LD_rA_rD:
	movb %al, reg_D
	movb reg_A, %al
	Continue

	.globl op_LD_rA_rE
op_LD_rA_rE:
	movb %al, reg_E
	movb reg_A, %al
	Continue

	.globl op_LD_rA_rF
op_LD_rA_rF:
	movb %al, reg_F
	movb reg_A, %al
	Continue

	.globl op_LD_rA_rL
op_LD_rA_rL:
	movb %al, reg_L
	movb reg_A, %al
	Continue

	.globl op_LD_rA_rA
op_LD_rA_rA:
	movb %al, reg_A
	movb reg_A, %al
	Continue

	.globl op_UNIMP
	.globl op_UNIMP2
	.globl z80_abort_instr
op_UNIMP2:
	decw %dx
op_UNIMP:
	decw %dx
	orb $1, SYMNAME(system_flags)
z80_abort_instr:
	movw %dx, reg_PC
	movb %ch, reg_F
	
	popal
	
	popl %ebp

	ret

/*
 * $Log: opcz80.S,v $
 * Revision 1.3  1999/06/14 16:50:35  nyef
 * fixed to compile clean with GNU as 2.9.1
 *
 * Revision 1.2  1999/01/02 17:24:02  nyef
 * added many instructions.
 *
 * Revision 1.1  1999/01/01 20:43:51  nyef
 * Initial revision
 *
 */
