/*
 * tool.h
 *
 * various definitions
 */

/* $Id: tool.h,v 1.6 1998/12/31 03:52:47 nyef Exp $ */

#ifndef __TOOL_H__
#define __TOOL_H__

#ifndef __EMU6502_H__
#include "emu6502.h"
#endif

extern unsigned long system_flags;
#define F_NONE    0x00000000
#define F_UNIMPL  0x00000001
#define F_BREAK   0x00000002
#define F_QUIT    0x00000004
#define F_GUI     0x00000008

extern char *romfilename; /* name of rom file */
extern unsigned char *romimage;   /* Cart Rom Image */
extern unsigned char *ramblock;   /* System and Cart Ram */
extern int romsize; /* Size of Rom Image */

#define read_byte(context, offset) ((unsigned char)(*((unsigned char *)(&context[(offset)]))))
#define read_word(context, offset) ((unsigned short)(*((unsigned short *)(&context[(offset)]))))
#define read_long(context, offset) ((unsigned long)(*((unsigned long *)(&context[(offset)]))))

void read_romimage(char *filename);
void activate_system(int system_type, int startup_deb);


#endif /* __TOOL_H__ */

/*
 * $Log: tool.h,v $
 * Revision 1.6  1998/12/31 03:52:47  nyef
 * added macro read_long.
 *
 * Revision 1.5  1998/12/21 02:59:04  nyef
 * added char * romfilename to save the name of the rom file.
 *
 * Revision 1.4  1998/11/17 00:02:18  nyef
 * expanded system flag (F_xxx) defines to 8 digits.
 * added system flag F_GUI for use by user interface code.
 *
 * Revision 1.3  1998/08/01 18:40:59  nyef
 * added prototypes for read_romimage() and activate_system().
 *
 * Revision 1.2  1998/07/12 23:08:03  nyef
 * added romsize definition
 *
 * Revision 1.1  1998/07/11 22:19:11  nyef
 * Initial revision
 *
 */
