/*
 * ui.h
 *
 * user interface interface
 */

/* $Id: ui.h,v 1.4 1999/06/05 02:42:04 nyef Exp $ */

#ifndef __UI_H__
#define __UI_H__

/* debug console interface */

void deb_printf(const char *fmt, ...);


/* timeslicer interface */

void set_timeslice(void (*proc)(void *), void *data);
void unset_timeslice(void);


/* shutdown callback */

typedef void (*shutdown_t)(void);
extern shutdown_t dn_shutdown;


/* joypad interface */

/*
 * joypad buttons are: UP, DOWN, LEFT, RIGHT, whatever,
 *    START (opt), SELECT (opt)
 */

struct joypad_template {
    int num_buttons;
    unsigned long buttons[0];
};

struct joypad {
    const struct joypad_template *template;
    unsigned long data;
};

int ui_register_joypad(struct joypad *pad);
void ui_update_joypad(struct joypad *pad);

#endif /* __UI_H__ */

/*
 * $Log: ui.h,v $
 * Revision 1.4  1999/06/05 02:42:04  nyef
 * added new joypad interface
 *
 * Revision 1.3  1999/04/17 20:11:27  nyef
 * changed shutdown() to dn_shutdown().
 *
 * Revision 1.2  1998/12/21 02:58:13  nyef
 * added a shutdown callback.
 *
 * Revision 1.1  1998/08/02 04:13:25  nyef
 * Initial revision
 *
 */
